2 # Copyright (c) 1998-2001 Robert Woodcock <rcw@debian.org>
3 # Copyright (c) 2003-2005 Jesus Climent <jesus.climent@hispalinux.es>
4 # This code is hereby licensed for public consumption under either the
5 # GNU GPL v2 or greater, or Larry Wall's Artistic license - your choice.
7 # You should have received a copy of the GNU General Public License
8 # along with this program; if not, write to the Free Software
9 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
11 # Copyright for this work is to expire January 1, 2010, after which it
12 # shall be public domain.
18 echo "This is abcde v$VERSION."
19 echo "Usage: abcde [options] [tracks]"
21 echo "-1 Encode the whole CD in a single file"
22 echo "-a <action1[,action2]...>"
23 echo " Actions to perform (cddb,read,normalize,encode,tag,move,playlist,clean)"
24 #echo "-A Experimental actions (retag, transcode)"
25 echo "-b Batch mode: enable album normalization and nogap encoding"
27 echo " Specify a configuration file (overrides system and user config files)"
29 echo " Specify discid to resume from (only needed if you no longer have the cd)"
31 echo " Specify CDROM device to grab"
32 echo "-D Debugging mode (equivalent to sh -x abcde)"
33 echo "-e Erase encoded track information from status file"
34 #echo "-E Set the encoding information for the tags"
35 echo "-h This help information"
36 #echo "-i Tag files while encoding, when possible (local only) -NWY-"
37 echo "-j <#> Number of encoder processes to run at once (localhost)"
38 echo "-k Keep the wav tracks for later use"
39 echo "-l Use low disk space algorithm"
40 echo "-L Use local CDDB storage directory"
41 echo "-n No lookup. Don't query CDDB, just create and use template"
42 echo "-N Noninteractive. Never prompt for anything"
43 echo "-m Modify playlist to include CRLF endings, to comply with some players"
44 echo "-M Create a CUE file"
45 echo "-o <type1[,type2]...>"
46 echo " Output file type(s) (vorbis,mp3,flac,spx,mpc). Defaults to vorbis"
47 echo "-p Pad track numbers with 0's (if less than 10 tracks)"
48 echo "-P Use UNIX pipes to read+encode without wav files"
49 echo "-r <host1[,host2]...>"
50 echo " Also encode on these remote hosts"
51 echo "-R Add replaygain values to the tag info (only for vorbis,flac)"
53 echo " Show dielfs from the CDDB info (year,genre)"
54 echo "-S <#> Set the CD speed"
55 #echo "-t File types to preprocess (wav)"
56 #echo "-T Set postprocessing options"
57 echo "-t <#> Start the track numbering at a given number"
58 echo "-T <#> Same as -t but modifies tag numbering"
59 echo "-v Show version number and exit"
60 echo "-V Be a bit more verbose about what is happening behind the scenes"
61 echo "-x Eject CD after all tracks are read"
63 echo " Add a comment to the CD tracks"
64 echo "-W <#> Contatenate CDs: -T #01 -w \"CD #\""
66 echo "Tracks is a space-delimited list of tracks to grab."
67 echo "Ranges specified with hyphens are allowed (i.e., 1-5)."
69 #echo "Double hyphens are used to concatenate tracks"
72 # Funtions to replace the need of seq, which is too distribution dependant.
76 while [ $i -ne `expr $2 + 1` ]
86 if echo i | grep -q "[[:digit:]]" ; then
87 while [ $i -ne `expr $2 + 1` ]
94 echo "abcde: syntax error while processing track numbers" >&2
99 # Functions to replace the need of awk {print $1} and {print $NF}
102 if [ X"$1" = "X" ]; then
103 for first in `cat`; do
114 if [ X"$1" = "X" ]; then
115 for stdin in `cat`; do
119 for last in $@ ; do :; done
124 # checkstatus [blurb]
125 # Returns "0" if the blurb was found, returns 1 if it wasn't
126 # Puts the blurb content, if available, on stdout.
127 # Otherwise, returns "".
130 # Take the last line in the status file if there's multiple matches
132 BLURB=$(egrep $PATTERN "$ABCDETEMPDIR/status" | tail -n 1)
134 if [ -z "$BLURB" ]; then
139 # See if there's a = in it
140 if [ "$(echo $BLURB | grep -c =)" != "0" ]; then
141 echo "$(echo $BLURB | cut -f2- -d=)"
147 # checkerrors [blurb]
148 # Returns "0" if the blurb was found (meaning there was an error),
149 # returns 1 if it wasn't (yes this is a little backwards).
150 # Does not print the blurb on stdout.
151 # Otherwise, returns "".
154 if [ -e "$ABCDETEMPDIR/errors" ]; then :; else
157 # Take the last line in the status file if there's multiple matches
159 BLURB="$(egrep $PATTERN "$ABCDETEMPDIR/errors" | tail -n 1)"
161 if [ -z "$BLURB" ]; then
162 # negative, we did not have a negative...
165 # affirmative, we had a negative...
171 # Finds the right pager in the system to display a file
175 # Use the debian sensible-pager wrapper to pick the pager
176 # user has requested via their $PAGER environment variable
177 if [ -x "/usr/bin/sensible-pager" ]; then
178 /usr/bin/sensible-pager "$PAGEFILE"
179 elif [ -x "$PAGER" ]; then
180 # That failed, try to load the preferred editor, starting
181 # with their PAGER variable
183 # If that fails, check for less
184 elif [ -x /usr/bin/less ]; then
185 /usr/bin/less -f "$PAGEFILE"
186 # more should be on all UNIX systems
187 elif [ -x /bin/more ]; then
188 /bin/more "$PAGEFILE"
190 # No bananas, just cat the thing
195 # run_command [blurb] [command...]
196 # Runs a command, silently if necessary, and updates the status file
201 # See if this is supposed to be silent
202 if [ "$(checkstatus encode-output)" = "loud" ]; then
206 # Special case for SMP, since
207 # encoder output is never displayed, don't mute echos
208 if [ -z "$BLURB" -a "$MAXPROCS" != "1" ]; then
217 normalize|normalize-audio)
218 if [ "$RETURN" = "2" ]; then
219 # File was already normalized.
224 if [ "$RETURN" != "0" ]; then
225 # Put an error in the errors file. For various reasons we
226 # can't capture a copy of the program's output but we can
227 # log what we attempted to execute and the error code
228 # returned by the program.
229 if [ "$BLURB" ]; then
232 echo "${TWEAK}returned code $RETURN: $@" >> "$ABCDETEMPDIR/errors"
233 return $RETURN # Do not pass go, do not update the status file
235 if [ "$BLURB" ]; then
236 echo $BLURB >> "$ABCDETEMPDIR/status"
240 # relpath() and slash() are Copyright (c) 1999 Stuart Ballard and
241 # distributed under the terms of the GNU GPL v2 or later, at your option
243 # Function to determine if a word contains a slash.
252 # Function to give the relative path from one file to another.
253 # Usage: relpath fromfile tofile
254 # eg relpath music/Artist/Album.m3u music/Artist/Album/Song.mp3
255 # (the result would be Album/Song.mp3)
256 # Output is relative path to $2 from $1 on stdout
258 # This code has the following restrictions:
259 # Multiple ////s are not collapsed into single /s, with strange effects.
260 # Absolute paths and ../s are handled wrong in FR (but they work in TO)
261 # If FR is a directory it must have a trailing /
269 /*) ;; # No processing is needed for absolute paths
271 # Loop through common prefixes, ignoring them.
272 while slash "$FR" && [ "$(echo "$FR" | cut -d/ -f1)" = "$(echo "$TO" | cut -d/ -f1)" ]
274 FR="$(echo "$FR" | cut -d/ -f2-)"
275 TO="$(echo "$TO" | cut -d/ -f2-)"
277 # Loop through directory portions left in FR, adding appropriate ../s.
280 FR="$(echo "$FR" | cut -d/ -f2-)"
290 # Finds an specific field from cddbinfo
292 # TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2 -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')
293 # TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | head -n 1 | cut -f2 -d= | tr -d \[:cntrl:\])
294 # TRACKNAME="$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2- -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')"
300 TRACKNAME="$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | head -n 1 | cut -f2- -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')"
303 TRACKNAME="$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2- -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')"
309 # Get the track number we are going to use for different actions
312 if [ -n "$STARTTRACKNUMBER" ] ; then
313 # Get the trackpadding from the current track
314 CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
315 TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - $FIRSTTRACK ))
317 TRACKNUM=${UTRACKNUM}
323 if checkstatus replaygain; then :; else
324 run_command "" echo "Adding reply-gain information..."
325 for OUTPUT in $( echo $OUTPUTTYPE | tr , \ )
326 # THE OUTPUT NEEDS TO BE CORRECTED WITH THE CONTAINER?
330 OUTPUT=$OGGOUTPUTCONTAINER
333 OUTPUT=$FLACOUTPUTCONTAINER
337 for UTRACKNUM in $TRACKQUEUE
339 CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
340 do_getcddbinfo TRACKNAME
342 TRACKFILE="$(mungefilename "$TRACKNAME")"
343 ARTISTFILE="$(mungefilename "$TRACKARTIST")"
344 ALBUMFILE="$(mungefilename "$DALBUM")"
346 if [ "$VARIOUSARTISTS" = "y" ]; then
347 OUTPUTFILE=$(eval echo $VAOUTPUTFORMAT)
349 OUTPUTFILE=$(eval echo $OUTPUTFORMAT)
351 OUTPUTFILES="$OUTPUTDIR/$OUTPUTFILE.$OUTPUT $OUTPUTFILES"
355 run_command replaygain-flac $METAFLAC --add-replay-gain $OUTPUTFILES
358 run_command replaygain-vorbis $VORBISGAIN --album $OUTPUTFILES
363 if checkerrors replaygain-.{3,6}; then
364 run_command replaygain false
366 run_command replaygain true
371 # This code splits the a Various Artist track name from one of the following
374 # forward: Artist / Track
375 # forward-dash: Artist - Track
376 # reverse: Track / Artist
377 # reverse-dash: Track - Artist
378 # colon: Artist: Track
379 # trailing-paren: Artist (Track)
382 # VARIOUSARTISTS, VARIOUSARTISTSTYLE, TRACKNAME, TRACKARTIST
385 if [ "$VARIOUSARTISTS" = "y" ] && [ ! "$ONETRACK" = "y" ]; then
386 case "$VARIOUSARTISTSTYLE" in
388 DTITLEARTIST="$(echo "$TRACKNAME" | sed 's- / -~-g')"
389 TRACKARTIST="$(echo "$DTITLEARTIST" | cut -f1 -d~)"
390 TRACKNAME="$(echo "$DTITLEARTIST" | cut -f2 -d~)"
393 DTITLEARTIST="$(echo "$TRACKNAME" | sed 's, - ,~,g')"
394 TRACKARTIST="$(echo "$DTITLEARTIST" | cut -f1 -d~)"
395 TRACKNAME="$(echo "$DTITLEARTIST" | cut -f2 -d~)"
398 DTITLEARTIST="$(echo "$TRACKNAME" | sed 's- / -~-g')"
399 TRACKARTIST="$(echo "$DTITLEARTIST" | cut -f2 -d~)"
400 TRACKNAME="$(echo "$DTITLEARTIST" | cut -f1 -d~)"
403 DTITLEARTIST="$(echo "$TRACKNAME" | sed 's, - ,~,g')"
404 TRACKARTIST="$(echo "$DTITLEARTIST" | cut -f2 -d~)"
405 TRACKNAME="$(echo "$DTITLEARTIST" | cut -f1 -d~)"
408 DTITLEARTIST="$(echo "$TRACKNAME" | sed 's-: -~-g')"
409 TRACKARTIST="$(echo "$DTITLEARTIST" | cut -f1 -d~)"
410 TRACKNAME="$(echo "$DTITLEARTIST" | cut -f2 -d~)"
413 DTITLEARTIST="$(echo "$TRACKNAME" | sed 's,^\(.*\) (\(.*\)),\1~\2,')"
414 TRACKARTIST="$(echo "$DTITLEARTIST" | cut -f2 -d~)"
415 TRACKNAME="$(echo "$DTITLEARTIST" | cut -f1 -d~)"
418 elif [ "$VARIOUSARTISTS" = "y" ] && [ "$ONETRACK" = "y" ]; then
419 TRACKARTIST="Various"
421 TRACKARTIST="$DARTIST"
426 local genre=$(echo "${@}" | tr '[A-Z]' '[a-z]')
430 "classic rock") id=1 ;;
448 "industrial") id=19 ;;
449 "alternative") id=20 ;;
451 "death metal") id=22 ;;
453 "soundtrack") id=24 ;;
454 "euro-techno") id=25 ;;
458 "jazz+funk") id=29 ;;
461 "classical") id=32 ;;
462 "instrumental") id=33 ;;
466 "sound clip") id=37 ;;
469 "alt. rock") id=40 ;;
474 "meditative") id=45 ;;
475 "instrum. pop") id=46 ;;
476 "instrum. rock") id=47 ;;
480 "techno-indust.") id=51 ;;
481 "electronic") id=52 ;;
483 "eurodance") id=54 ;;
485 "southern rock") id=56 ;;
490 "christian rap") id=61 ;;
491 "pop/funk"|"pop / funk") id=62 ;;
493 "native american") id=64 ;;
496 "psychadelic") id=67 ;;
498 "showtunes") id=69 ;;
502 "acid punk") id=73 ;;
503 "acid jazz") id=74 ;;
507 "rock & roll") id=78 ;;
508 "hard rock") id=79 ;;
510 "folk/rock") id=81 ;;
511 "national folk") id=82 ;;
518 "bluegrass") id=89 ;;
519 "avantgarde") id=90 ;;
520 "gothic rock") id=91 ;;
521 "progress. rock") id=92 ;;
522 "psychadel. rock") id=93 ;;
523 "symphonic rock") id=94 ;;
524 "slow rock") id=95 ;;
527 "easy listening") id=98 ;;
533 "chamber music") id=104 ;;
535 "symphony") id=106 ;;
536 "booty bass") id=107 ;;
538 "porn groove") id=109 ;;
540 "slow jam") id=111 ;;
544 "folklore") id=115 ;;
546 "power ballad") id=117 ;;
547 "rhythmic soul") id=118 ;;
548 "freestyle") id=119 ;;
550 "punk rock") id=121 ;;
551 "drum solo") id=122 ;;
552 "a capella") id=123 ;;
553 "euro-house") id=124 ;;
554 "dance hall") id=125 ;;
556 "drum & bass") id=127 ;;
557 "club-house") id=128 ;;
558 "hardcore") id=129 ;;
562 "negerpunk") id=133 ;;
563 "polsk punk") id=134 ;;
565 "christian gangsta rap") id=136 ;;
566 "heavy metal") id=137 ;;
567 "black metal") id=138 ;;
568 "crossover") id=139 ;;
569 "contemporary christian")id=140 ;;
570 "christian rock") id=141 ;;
571 "merengue") id=142 ;;
573 "thrash metal") id=144 ;;
576 "synthpop") id=147 ;;
577 "rock/pop"|"rock / pop") id=148 ;;
584 # do_tag [tracknumber]
585 # id3 tags a filename
587 # TRACKS, TRACKNAME, TRACKARTIST, TAGGER, TAGGEROPTS, VORBISCOMMENT, METAFLAC,
588 # COMMENT, DALBUM, DARTIST, CDYEAR, CDGENRE (and temporarily) ID3TAGV
591 COMMENTOUTPUT="$(eval echo ${COMMENT})"
592 run_command '' echo "Tagging track $1 of $TRACKS: $TRACKNAME..."
593 # If we want to start the tracks with a given number, we need to modify the
594 # TRACKNUM value before evaluation
595 # if [ -n "$STARTTRACKNUMBER" -a -n "$STARTTRACKNUMBERTAG" ] ; then
596 # # Get the trackpadding from the current track
597 # CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
598 # TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - $FIRSTTRACK ))
600 if [ -n "$STARTTRACKNUMBERTAG" ] ; then
603 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
607 # id3v2 v0.1.9 claims to have solved the -c bug, so we merge both id3 and id3v2
608 GENREID=$(do_getgenreid "${CDGENRE}")
613 # FIXME # track numbers in mp3 come with 1/10, so we cannot happily substitute them with $TRACKNUM
614 run_command tagtrack-$OUTPUT-$1 $TAGGER $TAGGEROPTS --commen=::"$COMMENTOUTPUT" \
615 -A "$DALBUM" -a "$TRACKARTIST" -t "$TRACKNAME" -Y "$CDYEAR" \
616 -G "$GENREID" -n "${TRACKNUM:-$1}" "${TRACKNUM:+-N $TRACKS}" \
617 "${ENCODING:+--set-encoding=$ENCODING}"
618 "$ABCDETEMPDIR/track$1.$OUTPUT"
621 # FIXME # track numbers in mp3 come with 1/10, so we cannot happily substitute them with $TRACKNUM
622 run_command tagtrack-$OUTPUT-$1 $TAGGER $TAGGEROPTS -c "$COMMENTOUTPUT" \
623 -A "$DALBUM" -a "$TRACKARTIST" -t "$TRACKNAME" -y "$CDYEAR" \
624 -g "$GENREID" -T "${TRACKNUM:-$1/$TRACKS}" \
625 "$ABCDETEMPDIR/track$1.$OUTPUT"
630 case "$OGGENCODERSYNTAX" in
632 # vorbiscomment can't do in-place modification, mv the file first
633 if [ -f "$ABCDETEMPDIR/track$1.$OGGOUTPUTCONTAINER" -a ! -f "$ABCDETEMPDIR/track$1.uncommented.$OGGOUTPUTCONTAINER" ]; then
634 mv "$ABCDETEMPDIR/track$1.$OGGOUTPUTCONTAINER" "$ABCDETEMPDIR/track$1.uncommented.$OGGOUTPUTCONTAINER"
637 # These are from http://www.xiph.org/ogg/vorbis/doc/v-comment.html
638 echo ARTIST="$TRACKARTIST"
640 echo TITLE="$TRACKNAME"
641 if [ -n "$CDYEAR" ]; then
644 if [ -n "$CDGENRE" ]; then
645 echo GENRE="$CDGENRE"
647 echo TRACKNUMBER=${TRACKNUM:-$1}
648 echo CDDB=$CDDBDISCID
649 if [ "$(eval echo ${COMMENT})" != "" ]; then
650 case "$COMMENTOUTPUT" in
651 *=*) echo "$COMMENTOUTPUT";;
652 *) echo COMMENT="$COMMENTOUTPUT";;
655 ) | run_command tagtrack-$OUTPUT-$1 $VORBISCOMMENT $VORBISCOMMENTOPTS -w \
656 "$ABCDETEMPDIR/track$1.uncommented.$OGGOUTPUTCONTAINER" "$ABCDETEMPDIR/track$1.$OGGOUTPUTCONTAINER"
657 # Doublecheck that the commented file was created successfully before wiping the original
658 if [ -f "$ABCDETEMPDIR/track$1.$OGGOUTPUTCONTAINER" ]; then
659 rm -f "$ABCDETEMPDIR/track$1.uncommented.$OGGOUTPUTCONTAINER"
661 mv "$ABCDETEMPDIR/track$1.uncommented.$OGGOUTPUTCONTAINER" "$ABCDETEMPDIR/track$1.$OGGOUTPUTCONTAINER"
668 echo ARTIST="$TRACKARTIST"
670 echo TITLE="$TRACKNAME"
671 if [ -n "$CDYEAR" ]; then
674 if [ -n "$CDGENRE" ]; then
675 echo GENRE="$CDGENRE"
677 echo TRACKNUMBER="${TRACKNUM:-$1}"
678 echo CDDB="$CDDBDISCID"
679 if [ "$(eval echo ${COMMENT})" != "" ]; then
680 case "$COMMENTOUTPUT" in
681 *=*) echo "$COMMENTOUTPUT";;
682 *) echo COMMENT="$COMMENTOUTPUT";;
685 ) | run_command tagtrack-$OUTPUT-$1 $METAFLAC $METAFLACOPTS --import-tags-from=- "$ABCDETEMPDIR/track$1.$FLACOUTPUTCONTAINER"
688 run_command tagtrack-$OUTPUT-$1 true
691 run_command tagtrack-$OUTPUT-$1 true
695 if checkerrors "tagtrack-(.{3,6})-$1"; then
696 run_command tagtrack-$1 false
698 run_command tagtrack-$1 true
705 # OUTPUTTYPE, {FOO}ENCODERSYNTAX, ENCNICE, ENCODER, ENCODEROPTS
708 # The commands here don't go through run_command because they're never supposed to be silenced
709 echo "Batch encoding tracks: $TRACKQUEUE"
710 OUTPUT=$(echo $OUTPUTTYPE | grep "mp3" )
713 case "$MP3ENCODERSYNTAX" in
718 for UTRACKNUM in $TRACKQUEUE
720 TRACKFILES="$TRACKFILES track$UTRACKNUM.wav"
722 nice $ENCNICE $MP3ENCODER $MP3ENCODEROPTS `[ "$MP3ENCODER" = "lame" ] && echo "--nogap"` $TRACKFILES
724 if [ "$RETURN" != "0" ]; then
725 echo "batch-encode: $ENCODER returned code $RETURN" >> errors
727 for UTRACKNUM in $TRACKQUEUE
729 echo encodetrack-$UTRACKNUM >> status
737 # Other encoders fall through to normal encoding as the tracks
738 # have not been entered in the status file.
741 # do_encode [tracknumber] [hostname]
742 # If no hostname is specified, encode locally
744 # TRACKS, TRACKNAME, TRACKARTIST, DISTMP3, DISTMP3OPTS, {FOO}ENCODERSYNTAX, OUTPUTTYPE, ENCODEROPTS, DALBUM, DARTIST, ENCNICE, CDYEAR, CDGENRE, COMMENT
747 if [ "$USEPIPES" = "y" ]; then
750 TEMPARG="PIPE_$MP3ENCODERSYNTAX"
753 TEMPARG="PIPE_$OGGENCODERSYNTAX"
756 TEMPARG="PIPE_$FLACENCODERSYNTAX"
759 TEMPARG="PIPE_$SPEEXENCODER"
762 TEMPARG="PIPE_$MPPENCODER"
765 IN="$( eval echo "\$$TEMPARG" )"
767 IN="$ABCDETEMPDIR/track$1.wav"
770 case "$MP3ENCODERSYNTAX" in
771 # FIXME # check if mp3enc needs -if for pipes
785 # We need IN to proceed, if we are not using pipes.
786 if [ -s "$IN" -o X"$USEPIPES" = "Xy" ] ; then
787 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
791 OUT="$ABCDETEMPDIR/track$1.$OGGOUTPUTCONTAINER"
794 OUT="$ABCDETEMPDIR/track$1.$FLACOUTPUTCONTAINER"
797 OUT="$ABCDETEMPDIR/track$1.$OUTPUT"
800 if [ X"$USEPIPES" = "Xy" ]; then
803 run_command '' echo "Encoding track $1 of $TRACKS: $TRACKNAME..."
804 RUN_COMMAND="run_command encodetrack-$OUTPUT-$1"
810 case "$MP3ENCODERSYNTAX" in
811 lame|gogo) $RUN_COMMAND nice $ENCNICE $MP3ENCODER $MP3ENCODEROPTS "$IN" "$OUT" ;;
812 bladeenc) $RUN_COMMAND nice $ENCNICE $MP3ENCODER $MP3ENCODEROPTS -quit "$IN" ;;
813 l3enc|xingmp3enc) $RUN_COMMAND nice $ENCNICE $MP3ENCODER "$IN" "$OUT" $MP3ENCODEROPTS ;;
814 # FIXME # Relates to the previous FIXME since it might need the "-if" removed.
815 mp3enc) $RUN_COMMAND nice $ENCNICE $MP3ENCODER -if "$IN" -of "$OUT" $MP3ENCODEROPTS ;;
819 $RUN_COMMAND nice $DISTMP3NICE $DISTMP3 $DISTMP3OPTS "$2" "$IN" "$OUT" >/dev/null 2>&1
826 case "$OGGENCODERSYNTAX" in
827 vorbize) $RUN_COMMAND nice $ENCNICE $OGGENCODER $OGGENCODEROPTS -w "$OUT" "$IN" ;;
828 oggenc) $RUN_COMMAND nice $ENCNICE $OGGENCODER $OGGENCODEROPTS -o "$OUT" "$IN" ;;
832 $RUN_COMMAND nice $DISTMP3NICE $DISTMP3 $DISTMP3OPTS "$2" "$IN" "$OUT" >/dev/null 2>&1
839 case "$FLACENCODERSYNTAX" in
840 flac) $RUN_COMMAND nice $ENCNICE $FLACENCODER $FLACENCODEROPTS -o "$OUT" "$IN" ;;
846 echo "$DISTMP3 $DISTMP3OPTS $2 $IN $OUT >/dev/null 2>&1"
847 $RUN_COMMAND nice $DISTMP3NICE $DISTMP3 $DISTMP3OPTS "$2" "$IN" "$OUT" > /dev/null 2>&1
852 if [ "$(eval echo ${COMMENT})" != "" ]; then
855 *) COMMENT="COMMENT=$COMMENT" ;;
857 COMMENT="--comment \"$COMMENT\""
859 # Quick hack to avoid tagging Ogg/Speex, since there is no other way to tag than inline tagging
860 if [ ! "$DOTAG" = "y" ]; then
861 $RUN_COMMAND nice $ENCNICE $SPEEXENCODER $SPEEXENCODEROPTS --author "$TRACKARTIST" --title "$TRACKNAME" "$COMMENT" "$IN" "$OUT"
863 $RUN_COMMAND nice $ENCNICE $SPEEXENCODER $SPEEXENCODEROPTS "$IN" "$OUT"
867 # MPP/MP+(Musepack) format (.mpc) is done locally, with inline
869 # I tried compiling the mppenc from corecodecs.org and got some
870 # errors, so I have not tried it myself.
871 ## FIXME ## Needs some cleanup to determine if an empty tag sent
872 ## FIXME ## to the encoder ends up empty.
873 $RUN_COMMAND nice $ENCNICE $MPPENCODER $MPPENCODEROPTS --artist "$TRACKARTIST" --album "$DALBUM" --title "$TRACKNAME" --track "$1" --genre "$CDGENRE" --year "$CDYEAR" --comment "$COMMENT" "$IN" "$OUT"
877 # Only remove .wav if the encoding succeeded
878 if checkerrors "encodetrack-(.{3,6})-$1"; then
879 run_command encodetrack-$1 false
881 run_command encodetrack-$1 true
882 if [ ! "$KEEPWAVS" = "y" ] ; then
887 run_command "" echo "HEH! The file we were about to encode disappeared:"
888 run_command "" echo ">> $IN"
889 run_command encodetrack-$1 false
893 # do_preprocess [tracknumber]
895 # TRACKS, TRACKNAME, TRACKARTIST, DISTMP3, DISTMP3OPTS, {FOO}ENCODERSYNTAX, OUTPUTTYPE, ENCODEROPTS, DALBUM, DARTIST, ENCNICE, CDYEAR, CDGENRE, COMMENT
898 # IN="$ABCDETEMPDIR/track$1.wav"
899 # # We need IN to proceed.
900 # if [ -s "$IN" ] ; then
901 # for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
903 # #OUT="$ABCDETEMPDIR/track$1.$OUTPUT"
904 # run_command '' echo "Pre-processing track $1 of $TRACKS..."
905 # case "$POSTPROCESSFORMAT" in
907 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $WAV_PRE $IF $OF ;;
909 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $MP3_PRE $IF $OF ;;
911 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $OGG_PRE $IF $OF ;;
913 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $FLAC_PRE $IF $OF ;;
915 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $SPX_PRE $IF $OF ;;
918 # # Only remove .wav if the encoding succeeded
919 # if checkerrors "preprocess-(.{3,4})-$1"; then
920 # run_command preprocess-$1 false
922 # run_command preprocess-$1 true
925 # if [ "$(checkstatus encode-output)" = "loud" ]; then
926 # echo "HEH! The file we were about to pre-process disappeared:"
929 # run_command preprocess-$1 false
934 # do_postprocess [tracknumber]
936 # TRACKS, TRACKNAME, TRACKARTIST, DISTMP3, DISTMP3OPTS, {FOO}ENCODERSYNTAX, OUTPUTTYPE, ENCODEROPTS, DALBUM, DARTIST, ENCNICE, CDYEAR, CDGENRE, COMMENT
939 # for POSTPROCESSFORMAT in $(echo $POSTPROCESSFORMATS | tr , \ )
941 # IN="$ABCDETEMPDIR/track$1.$POSTPROCESSFORMAT"
942 # # We need IN to proceed.
943 # if [ -s "$IN" ] ; then
944 # #OUT="$ABCDETEMPDIR/track$1.$OUTPUT"
945 # run_command '' echo "Post-processing track $1 of $TRACKS..."
946 # case "$POSTPROCESSFORMAT" in
948 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $MP3_POST $IF $OF ;;
950 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $OGG_POST $IF $OF ;;
952 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $FLAC_POST $IF $OF ;;
954 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $SPX_POST $IF $OF ;;
956 # # Only remove .wav if the encoding succeeded
957 # if checkerrors "postprocess-(.{3,4})-$1"; then
958 # run_command postprocess-$1 false
960 # run_command postprocess-$1 true
963 # if [ "$(checkstatus encode-output)" = "loud" ]; then
964 # echo "HEH! The file we were about to post-process disappeared:"
967 # run_command postprocess-$1 false
982 # MP3GAIN, MP3GAINOPTS, VORBISGAIN, VORBISGAINOPTS
986 # The commands here don't go through run_command because they're never supposed to be silenced
987 echo "Batch analizing gain in tracks: $TRACKQUEUE"
992 for UTRACKNUM in $TRACKQUEUE
994 MP3FILES="$TRACKFILES track$UTRACKNUM.mp3"
996 # XXX: Hard-coded batch option!
997 $NORMALIZER -b $NORMALIZEROPTS $TRACKFILES
999 if [ "$RETURN" != "0" ]; then
1000 echo "batch-normalize: $NORMALIZER returned code $RETURN" >> errors
1002 for UTRACKNUM in $TRACKQUEUE
1004 echo normalizetrack-$UTRACKNUM >> status
1010 # do_batch_normalize
1012 # NORMALIZER, NORMALIZEROPTS
1013 do_batch_normalize ()
1015 # The commands here don't go through run_command because they're never supposed to be silenced
1016 echo "Batch normalizing tracks: $TRACKQUEUE"
1021 for UTRACKNUM in $TRACKQUEUE
1023 TRACKFILES="$TRACKFILES track$UTRACKNUM.wav"
1025 # XXX: Hard-coded batch option!
1026 $NORMALIZER -b $NORMALIZEROPTS $TRACKFILES
1028 if [ "$RETURN" != "0" ]; then
1029 echo "batch-normalize: $NORMALIZER returned code $RETURN" >> errors
1031 for UTRACKNUM in $TRACKQUEUE
1033 echo normalizetrack-$UTRACKNUM >> status
1039 # do_normalize [tracknumber]
1041 # TRACKS, TRACKNAME, NORMALIZER, NORMALIZEROPTS
1044 IN="$ABCDETEMPDIR/track$1.wav"
1045 if [ -e "$IN" ] ; then
1046 run_command '' echo "Normalizing track $1 of $TRACKS: $TRACKNAME..."
1047 run_command normalizetrack-$1 $NORMALIZER $NORMALIZEROPTS "$IN"
1049 if [ "$(checkstatus encode-output)" = "loud" ]; then
1050 echo "HEH! The file we were about to normalize disappeared:"
1053 run_command normalizetrack-$1 false "File $IN was not found"
1057 # do_move [tracknumber]
1058 # Deduces the outfile from environment variables
1059 # Creates directory if necessary
1061 # TRACKNUM, TRACKNAME, TRACKARTIST, DALBUM, OUTPUTFORMAT, CDGENRE, CDYEAR
1064 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
1066 # Create ALBUMFILE, ARTISTFILE, TRACKFILE
1067 # Munge filenames as follows:
1072 # Eat control characters
1073 ALBUMFILE="$(mungefilename "$DALBUM")"
1074 ARTISTFILE="$(mungefilename "$TRACKARTIST")"
1075 TRACKFILE="$(mungefilename "$TRACKNAME")"
1076 GENRE="$(mungegenre "$GENRE")"
1077 YEAR="$(echo $CDYEAR)"
1078 # If we want to start the tracks with a given number, we need to modify the
1079 # TRACKNUM value before evaluation
1080 # if [ -n "$STARTTRACKNUMBER" ] ; then
1081 # # Get the trackpadding from the current track
1082 # CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
1083 # TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - $FIRSTTRACK ))
1085 # TRACKNUM=${UTRACKNUM}
1088 # Supported variables for OUTPUTFORMAT are GENRE, ALBUMFILE, ARTISTFILE,
1089 # TRACKFILE, and TRACKNUM.
1090 if [ "$VARIOUSARTISTS" = "y" ]; then
1091 OUTPUTFILE="$(eval echo "$VAOUTPUTFORMAT")"
1093 OUTPUTFILE="$(eval echo "$OUTPUTFORMAT")"
1095 if checkerrors "tagtrack-$OUTPUT-$1"; then :; else
1096 # Once we know the specific output was successful, we can change the OUTPUT to the value containing the container
1099 OUTPUT=$OGGOUTPUTCONTAINER
1102 OUTPUT=$FLACOUTPUTCONTAINER
1105 # Check that the directory for OUTPUTFILE exists, if it doesn't, create it
1106 OUTPUTFILEDIR="$(dirname "$OUTPUTDIR/$OUTPUTFILE")"
1107 # mkdir -p shouldn't return an error if the directory already exists
1108 mkdir -p "$OUTPUTFILEDIR"
1109 run_command movetrack-$1 mv "$ABCDETEMPDIR/track$1.$OUTPUT" "$OUTPUTDIR/$OUTPUTFILE.$OUTPUT"
1110 # Lets move the cue file
1111 if CUEFILE=$(checkstatus cuefile) >/dev/null ; then
1112 if [ -r "$ABCDETEMPDIR/$CUEFILE" ]; then
1113 if checkstatus movecue-$OUTPUT; then :; else
1114 # Silence the Copying output since it overlaps with encoding processes...
1115 #run_command '' vecho "Copying cue file to its destination directory..."
1116 if checkstatus onetrack >/dev/null ; then
1118 # NOTE: Creating a cue file with the 3-char-extension files is to comply with
1119 # http://brianvictor.tripod.com/mp3cue.htm#details
1120 [a-z0-9][a-z0-9][a-z0-9])
1121 run_command movecue-$OUTPUT cp "$ABCDETEMPDIR/$CUEFILE" "$OUTPUTDIR/$OUTPUTFILE.cue"
1124 run_command movecue-$OUTPUT cp "$ABCDETEMPDIR/$CUEFILE" "$OUTPUTDIR/$OUTPUTFILE.$OUTPUT.cue"
1128 run_command movecue-$OUTPUT cp "$ABCDETEMPDIR/$CUEFILE" "$OUTPUTFILEDIR/$CUEFILE"
1130 echo movecue-$OUTPUT >> "$ABCDETEMPDIR/status"
1139 # Create the playlist if wanted
1141 # PLAYLISTFORMAT, PLAYLISTDATAPREFIX, VAPLAYLISTFORMAT, VAPLAYLISTDATAPREFIX,
1142 # VARIOUSARTISTS, OUTPUTDIR
1145 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
1147 # Create a playlist file for the playlist data to go into.
1148 # We used to wipe it out if it existed. Now we request permision if interactive.
1149 for LASTTRACK in $TRACKQUEUE; do :; done
1150 ALBUMFILE="$(mungefilename "$DALBUM")"
1151 ARTISTFILE="$(mungefilename "$DARTIST")"
1152 GENRE=$(mungegenre "$GENRE")
1153 YEAR=${CDYEAR:-$CDYEAR}
1154 if [ "$VARIOUSARTISTS" = "y" ] ; then
1155 PLAYLISTFILE=$(eval echo $VAPLAYLISTFORMAT)
1157 PLAYLISTFILE=$(eval echo $PLAYLISTFORMAT)
1159 FINALPLAYLISTDIR=$(dirname "$OUTPUTDIR/$PLAYLISTFILE")
1160 mkdir -p "$FINALPLAYLISTDIR"
1161 if [ -s "$OUTPUTDIR/$PLAYLISTFILE" ]; then
1162 echo -n "Erase, Append to, or Keep the existing playlist file? [e/a/k] (e): " >&2
1163 if [ "$INTERACTIVE" = "y" ]; then
1164 while [ "$DONE" != "y" ]; do
1166 case $ERASEPLAYLIST in
1167 e|E|a|A|k|K) DONE=y ;;
1175 # Once we erase the playlist, we use append to create the new one.
1176 [ "$ERASEPLAYLIST" = "e" -o "$ERASEPLAYLIST" = "E" ] && rm -f "$OUTPUTDIR/$PLAYLISTFILE" && ERASEPLAYLIST=a
1178 # The playlist does not exist, so we can safelly use append to create the new list
1181 if [ "$ERASEPLAYLIST" = "a" -o "$ERASEPLAYLIST" = "A" ]; then
1182 touch "$OUTPUTDIR/$PLAYLISTFILE"
1183 for UTRACKNUM in $TRACKQUEUE
1185 # Shares some code with do_move since the filenames have to match
1186 CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
1187 #TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2 -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')
1188 do_getcddbinfo TRACKNAME
1190 TRACKFILE="$(mungefilename "$TRACKNAME")"
1191 ARTISTFILE="$(mungefilename "$TRACKARTIST")"
1192 ALBUMFILE="$(mungefilename "$DALBUM")"
1193 # If we want to start the tracks with a given number, we need to modify the
1194 # TRACKNUM value before evaluation
1195 # if [ -n "$STARTTRACKNUMBER" ] ; then
1196 # # Get the trackpadding from the current track
1197 # CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
1198 # TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - $FIRSTTRACK ))
1200 # TRACKNUM=${UTRACKNUM}
1203 if [ "$VARIOUSARTISTS" = "y" ]; then
1204 OUTPUTFILE=$(eval echo $VAOUTPUTFORMAT)
1206 OUTPUTFILE=$(eval echo $OUTPUTFORMAT)
1208 if [ "$VARIOUSARTISTS" = "y" ]; then
1209 if [ "$VAPLAYLISTDATAPREFIX" ] ; then
1210 echo ${VAPLAYLISTDATAPREFIX}$OUTPUTFILE.$OUTPUT >> "$OUTPUTDIR/$PLAYLISTFILE"
1212 relpath "$PLAYLISTFILE", "$OUTPUTFILE.$OUTPUT" >> "$OUTPUTDIR/$PLAYLISTFILE"
1215 if [ "$PLAYLISTDATAPREFIX" ]; then
1216 echo ${PLAYLISTDATAPREFIX}$OUTPUTFILE.$OUTPUT >> "$OUTPUTDIR/$PLAYLISTFILE"
1218 relpath "$PLAYLISTFILE", "$OUTPUTFILE.$OUTPUT" >> "$OUTPUTDIR/$PLAYLISTFILE"
1223 ## this will convert the playlist to have CRLF line-endings, if specified
1224 ## (some hardware players insist on CRLF endings)
1225 if [ "$DOSPLAYLIST" = "y" ]; then
1226 awk '{substr("\r",""); printf "%s\r\n", $0}' "$OUTPUTDIR/$PLAYLISTFILE" > "$ABCDETEMPDIR/PLAYLISTFILE.tmp"
1227 # mv -f "$ABCDETEMPDIR/PLAYLISTFILE.tmp" "$OUTPUTDIR/$PLAYLISTFILE"
1228 cat "$ABCDETEMPDIR/PLAYLISTFILE.tmp" | sed 's/\//\\/' > "$OUTPUTDIR/$PLAYLISTFILE"
1230 echo "playlistcomplete" >> "$ABCDETEMPDIR/status"
1235 # This essentially the start of things
1238 # Query the CD to get the track info, unless the user specified -C
1239 # or we are using some actions which do not need the CDDB data at all
1240 #if [ ! X"$EXPACTIONS" = "X" ]; then
1242 #elif [ -z "$DISCID" ]; then
1243 if [ -z "$DISCID" ]; then
1244 vecho -n "Getting CD track info... "
1245 # In OSX, unmount the disc before a query
1246 if [ "$OSFLAVOUR" = "OSX" ]; then
1247 disktool -u ${CDROM#/dev/}
1249 TRACKINFO=$($CDDISCID $CDROM)
1250 # Make sure there's a CD in there by checking cd-discid's return code
1251 if [ "$?" = "1" ]; then
1252 echo "abcde error: CD could not be read. Perhaps there's no CD in the drive?" >&2
1255 # In OSX, remount the disc again
1256 if [ "$OSFLAVOUR" = "OSX" ]; then
1257 disktool -m ${CDROM#/dev/}
1261 TRACKINFO=$(cat "$WAVOUTPUTDIR/abcde.$DISCID/discid")
1264 # Get a full enumeration of tracks, sort it, and put it in the TRACKQUEUE.
1265 # This needs to be done now because a section of the resuming code will need
1268 # get the number of digits to pad TRACKNUM with - we'll use this later
1269 # a CD can only hold 99 tracks, but since we support a feature for starting
1270 # numbering the tracks from a given number, we might need to set it as a
1271 # variable for the user to define... or obtain it somehow.
1272 if [ "$PADTRACKS" = "y" ] ; then
1276 ABCDETEMPDIR="$WAVOUTPUTDIR/abcde.$(echo $TRACKINFO | cut -f1 -d' ')"
1277 if [ -z "$TRACKQUEUE" ]; then
1278 if [ ! "$STRIPDATATRACKS" = "y" ]; then
1279 case "$CDROMREADERSYNTAX" in
1281 if [ "$WEHAVEACD" = "y" ]; then
1282 vecho "Querying the CD for audio tracks..."
1283 CDPARANOIAOUTPUT="$( $CDROMREADER -$CDPARANOIACDROMBUS $CDROM -Q --verbose 2>&1 )"
1285 if [ ! "$RET" = "0" ];then
1286 echo "Warning: Something went wrong while querying the CD... Maybe a DATA CD?"
1288 TRACKS="$( echo "$CDPARANOIAOUTPUT" | egrep '^[[:space:]]+[[:digit:]]' | tail -n 1 | get_first | tr -d "." | tr '\n' ' ' )"
1289 CDPARANOIAAUDIOTRACKS="$TRACKS"
1291 if [ -f "$ABCDETEMPDIR/status" ] && checkstatus cdparanoia-audio-tracks ; then
1292 TRACKS=$( cat "$ABCDETEMPDIR/cdparanoia-audio-tracks" )
1294 TRACKS=$(echo $TRACKINFO | cut -f2 -d' ')
1298 *) TRACKS=$(echo $TRACKINFO | cut -f2 -d' ') ;;
1301 TRACKS=$(echo $TRACKINFO | cut -f2 -d' ')
1303 if echo "$TRACKS" | grep "[[:digit:]]" > /dev/null 2>&1 ;then :;else
1304 echo "The disc does not contain any tracks. Giving up..."
1307 echo -n "Grabbing entire CD - tracks: "
1308 if [ ! "$PADTRACKS" = "y" ] ; then
1309 TRACKNUMPADDING=$(echo -n $TRACKS | wc -c | tr -d ' ')
1311 TRACKS=$(printf "%0.${TRACKNUMPADDING}d" $TRACKS)
1313 while [ "$X" -ne "$TRACKS" ]
1315 X=$(printf "%0.${TRACKNUMPADDING}d" $(expr $X + 1))
1316 TRACKQUEUE=$(echo "$TRACKQUEUE" $X)
1320 TRACKS=$(echo $TRACKINFO | cut -f2 -d' ')
1321 # User-supplied track queue.
1322 # Weed out non-numbers, whitespace, then sort and weed out duplicates
1323 TRACKQUEUE=$(echo $TRACKQUEUE | sed 's-[^0-9 ]--g' | tr ' ' '\n' | grep -v ^$ | sort -n | uniq | tr '\n' ' ' | sed 's- $--g')
1324 # Once cleaned, obtain the highest value in the trackqueue for number padding
1325 for LASTTRACK in $TRACKQUEUE; do :; done
1326 if [ ! "$PADTRACKS" = "y" ] ; then
1327 TRACKNUMPADDING=$(echo -n $LASTTRACK | wc -c | tr -d ' ')
1329 # Now we normalize the trackqueue
1330 for TRACK in $TRACKQUEUE ; do
1331 TRACKNUM=$(printf %0.${TRACKNUMPADDING}d $(expr ${TRACK} + 0 ))
1332 PADTRACKQUEUE=$(echo $PADTRACKQUEUE $TRACKNUM)
1334 TRACKQUEUE=$PADTRACKQUEUE
1335 echo Grabbing tracks: "$TRACKQUEUE"
1338 QUEUEDTRACKS=$(echo $TRACKQUEUE | wc -w | tr -d ' ')
1340 # We have the discid, create a temp directory after it to store all the temp
1343 if [ -e "$ABCDETEMPDIR" ]; then
1344 echo -n "abcde: attempting to resume from $ABCDETEMPDIR"
1345 # It already exists, see if it's a directory
1346 if [ ! -d "$ABCDETEMPDIR" ]; then
1347 # This is a file/socket/fifo/device/etc, not a directory
1350 echo "abcde: file $ABCDETEMPDIR already exists and does not belong to abcde." >&2
1351 echo "Please investigate, remove it, and rerun abcde." >&2
1355 # It's a directory, let's see if it's owned by us
1356 if [ ! -O "$ABCDETEMPDIR" ]; then
1357 # Nope, complain and exit
1359 echo "abcde: directory $ABCDETEMPDIR already exists and is not owned by you." >&2
1360 echo "Please investigate, remove it, and rerun abcde." >&2
1364 # See if it's populated
1365 if [ ! -f "$ABCDETEMPDIR/discid" ]; then
1366 # Wipe and start fresh
1367 echo "abcde: $ABCDETEMPDIR/discid not found. Abcde must remove and recreate" >&2
1368 echo -n "this directory to continue. Continue? [y/n] (n)" >&2
1369 if [ "$INTERACTIVE" = "y" ]; then
1375 if [ "$ANSWER" != "y" ]; then
1378 rm -rf "$ABCDETEMPDIR" || exit 1
1379 mkdir "$ABCDETEMPDIR"
1380 if [ "$?" -gt "0" ]; then
1381 # Directory already exists or could not be created
1382 echo "abcde: Temp directory $ABCDETEMPDIR could not be created." >&2
1386 # Everything is fine. Check for ^encodetracklocation-
1387 # and encode-output entries in the status file and
1388 # remove them. These are not relevant across sessions.
1389 if [ -f "$ABCDETEMPDIR/status" ]; then
1390 mv "$ABCDETEMPDIR/status" "$ABCDETEMPDIR/status.old"
1391 grep -v ^encodetracklocation- < "$ABCDETEMPDIR/status.old" \
1392 | grep -v ^encode-output > "$ABCDETEMPDIR/status"
1394 # Remove old error messages
1395 if [ -f "$ABCDETEMPDIR/errors" ]; then
1396 rm -f "$ABCDETEMPDIR/errors"
1400 # We are starting from scratch
1401 mkdir "$ABCDETEMPDIR"
1402 if [ "$?" -gt "0" ]; then
1403 # Directory already exists or could not be created
1404 echo "abcde: Temp directory $ABCDETEMPDIR could not be created." >&2
1407 cat /dev/null > "$ABCDETEMPDIR/status"
1409 if [ X"$MAKECUEFILE" = "Xy" -a X"$WEHAVEACD" = "Xy" ]; then
1410 if checkstatus cuefile > /dev/null 2>&1 ; then :; else
1411 CUEFILE=cue-$(echo "$TRACKINFO" | cut -f1 -d' ').txt
1412 vecho "Creating cue file..."
1413 if $CUEREADER $CUEREADEROPTS > "$ABCDETEMPDIR/$CUEFILE"; then
1414 echo cuefile=$CUEFILE >> "$ABCDETEMPDIR/status"
1416 echo "abcde: reading the CUE sheet with mkcue is still considered experimental"
1417 echo "abcde: and there was a problem with the CD reading. abcde will continue,"
1418 echo "abcde: but consider reporting the problem to the abcde author"
1422 # If we got the CDPARANOIA status and it is not recorded, save it now
1423 if [ -n "$CDPARANOIAAUDIOTRACKS" ]; then
1424 if checkstatus cdparanoia-audio-tracks; then :; else
1425 if echo "$CDPARANOIAAUDIOTRACKS" >> "$ABCDETEMPDIR/cdparanoia-audio-tracks"; then
1426 echo "cdparanoia-audio-tracks" >> "$ABCDETEMPDIR/status"
1431 # Create the discid file
1432 echo "$TRACKINFO" > "$ABCDETEMPDIR/discid"
1436 # Create a proper CUE file based on the CUE file we created before.
1439 # FIXME # we can get the name of the cuefile from the status file
1440 if CUEFILE_IN="$ABCDETEMPDIR"/$(checkstatus cuefile); then
1441 CUEFILE_OUT=$CUEFILE_IN.out
1442 ### FIXME ### checkstatus cddb
1443 if [ -e "$CDDBDATA" ]; then
1444 vecho "Adding metadata to the cue file..."
1445 # FIXME It doesn't preserve spaces! Why?
1446 # FIXME parse $track into PERFORMER and TITLE - abcde already has code for this?
1448 echo "PERFORMER \"$DARTIST\"" >> "$CUEFILE_OUT"
1449 echo "TITLE \"$DALBUM\"" >> "$CUEFILE_OUT"
1450 cat "$CUEFILE_IN" | while read line
1452 if echo "$line" | grep -q "INDEX"
1454 eval track="\$TRACK$n"
1456 echo "TITLE \"$track\"" >> "$CUEFILE_OUT"
1458 echo "$line" >> "$CUEFILE_OUT"
1460 mv "$CUEFILE_OUT" "$CUEFILE_IN"
1461 echo "cleancuefile" >> "$ABCDETEMPDIR/status"
1467 # Parses a CDDB file and outputs the title and the track names.
1468 # Variables: CDDBFILE
1472 # List out disc title/author and contents
1473 if [ "$ONETRACK" = "y" ]; then
1474 vecho "ONETRACK mode selected: displaying only the title of the CD..."
1476 echo "---- $(grep DTITLE "${CDDBPARSEFILE}" | cut '-d=' -f2- | tr -d \\r\\n ) ----"
1477 if [ X"$SHOWCDDBYEAR" = "Xy" ]; then
1478 PARSEDYEAR=$(grep DYEAR "${CDDBPARSEFILE}" | cut '-d=' -f2-)
1479 if [ ! X"$PARSEDYEAR" = "X" ]; then
1480 echo "Year: $PARSEDYEAR"
1483 if [ X"$SHOWCDDBGENRE" = "Xy" ]; then
1484 PARSEDGENRE=$(grep DGENRE "${CDDBPARSEFILE}" | cut '-d=' -f2-)
1485 if [ ! X"$PARSEDGENRE" = "X" ]; then
1486 echo "Genre: $PARSEDGENRE"
1489 if [ ! "$ONETRACK" = "y" ]; then
1490 for TRACK in $(f_seq_row 1 $TRACKS)
1492 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "${CDDBPARSEFILE}" | cut -f2- -d= | tr -d \\r\\n)"
1498 # Check for a local CDDB file, and report success
1501 if checkstatus cddb-readcomplete && checkstatus cddb-choice >/dev/null; then :; else
1503 CDDBLOCALSUCCESS="n"
1504 CDDBDISCID=$(echo $TRACKINFO | cut -d' ' -f1)
1505 CDDBLOCALFILE="${CDDBLOCALDIR}/${CDDBDISCID}"
1508 # If the user has selected to check a local CDDB repo, we proceed with it
1509 if [ -r "${CDDBLOCALFILE}" ]; then
1510 # List out disc title/author and contents
1511 do_cddbparse "${CDDBLOCALFILE}"
1512 echo -n "Locally cached CDDB entry found, use it? [y/n] (y): "
1513 if [ "$INTERACTIVE" = "y" ]; then
1515 while [ "$USELOCALRESP" != "y" ] && [ "$USELOCALRESP" != "n" ] && [ "$USELOCALRESP" != "" ] ; do
1516 echo -n 'Invalid selection. Please answer "y" or "n": '
1519 [ x"$USELOCALRESP" = "x" ] && USELOCALRESP="y"
1523 if [ "$USELOCALRESP" = "y" ]; then
1524 #echo "Using local copy of CDDB data"
1525 cp "${CDDBLOCALFILE}" "$ABCDETEMPDIR/cddbread.1"
1526 echo 999 > "$ABCDETEMPDIR/cddbquery" # Assuming 999 isn't used by CDDB
1527 echo cddb-readcomplete >> "$ABCDETEMPDIR/status"
1528 do_cddbparse "${CDDBLOCALFILE}" > "$ABCDETEMPDIR/cddbchoices"
1529 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1530 CDDBLOCALSUCCESS="y"
1532 #echo "Not using local copy of CDDB data"
1533 CDDBLOCALSUCCESS="n"
1536 CDDBLOCALSUCCESS="n"
1544 # Perform CDDB protocol version check if it hasn't already been done
1545 if checkstatus cddb-statcomplete; then :; else
1546 if [ "$CDDBAVAIL" = "n" ]; then
1548 echo 503 > "$ABCDETEMPDIR/cddbstat"
1551 CDDBUSER=$(echo $HELLOINFO | cut -f1 -d'@')
1552 CDDBHOST=$(echo $HELLOINFO | cut -f2- -d'@')
1553 while test $rc -eq 1 -a $CDDBPROTO -ge 3; do
1554 vecho "Checking CDDB server status..."
1555 $CDDBTOOL stat $CDDBURL $CDDBUSER $CDDBHOST $CDDBPROTO > "$ABCDETEMPDIR/cddbstat"
1556 RESPONSECODE=$(head -n 1 "$ABCDETEMPDIR/cddbstat" | cut -f1 -d' ')
1557 case "$RESPONSECODE" in
1558 210) # 210 OK, status information follows (until terminating `.')
1561 501|*) # 501 Illegal CDDB protocol level: <n>.
1562 CDDBPROTO=`expr $CDDBPROTO - 1`
1566 if test $rc -eq 1; then
1570 echo cddb-statcomplete >> "$ABCDETEMPDIR/status"
1578 CDDBDISCID=$(echo $TRACKINFO | cut -d' ' -f1)
1579 CDDBLOCALFILE="${CDDBLOCALDIR}/${CDDBDISCID}"
1581 # Perform CDDB query if it hasn't already been done
1582 if checkstatus cddb-querycomplete; then :; else
1583 if [ "$CDDBAVAIL" = "n" ]; then
1585 echo 503 > "$ABCDETEMPDIR/cddbquery"
1586 # The default CDDBLOCALSUCCESS is "n"
1587 # This part will be triggered if the user CDDB repo does not
1588 # contain the entry, or if we are not trying to use the repo.
1590 vecho "Querying the CDDB server..."
1591 CDDBUSER=$(echo $HELLOINFO | cut -f1 -d'@')
1592 CDDBHOST=$(echo $HELLOINFO | cut -f2- -d'@')
1593 $CDDBTOOL query $CDDBURL $CDDBPROTO $CDDBUSER $CDDBHOST $TRACKINFO > "$ABCDETEMPDIR/cddbquery"
1599 # no match found in database,
1600 # wget/fetch error, or user requested not to use CDDB
1601 # Make up an error code (503) that abcde
1602 # will recognize in do_cddbread
1603 # and compensate by making a template
1604 echo 503 > "$ABCDETEMPDIR/cddbquery"
1606 *) # strange and unknown error
1607 echo ERRORCODE=$ERRORCODE
1608 echo "abcde: $CDDBTOOL returned unknown error code"
1612 echo cddb-querycomplete >> "$ABCDETEMPDIR/status"
1619 # If it's not to be used, generate a template.
1620 # Then, display it (or them) and let the user choose/edit it
1621 if checkstatus cddb-readcomplete; then :; else
1622 vecho "Obtaining CDDB results..."
1623 # If CDDB is to be used, interpret the query results and read all
1624 # the available entries.
1625 rm -f "$ABCDETEMPDIR/cddbchoices"
1626 CDDBCHOICES=1 # Overridden by multiple matches
1627 RESPONSECODE=$(head -n 1 "$ABCDETEMPDIR/cddbquery" | cut -f1 -d' ')
1628 case "$RESPONSECODE" in
1630 # One exact match, retrieve it
1631 # 200 [section] [discid] [artist] / [title]
1632 if checkstatus cddb-read-1-complete; then :; else
1633 echo -n "Retrieving 1 CDDB match..." >> "$ABCDETEMPDIR/cddbchoices"
1634 $CDDBTOOL read $CDDBURL $CDDBPROTO $CDDBUSER $CDDBHOST $(cut -f2,3 -d' ' "$ABCDETEMPDIR/cddbquery") > "$ABCDETEMPDIR/cddbread.1"
1635 echo "done." >> "$ABCDETEMPDIR/cddbchoices"
1636 echo cddb-read-1-complete >> "$ABCDETEMPDIR/status"
1637 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1639 # List out disc title/author and contents
1640 echo ---- "$(cut '-d ' -f4- "$ABCDETEMPDIR/cddbquery")" ---- >> "$ABCDETEMPDIR/cddbchoices"
1641 for TRACK in $(f_seq_row 1 $TRACKS)
1643 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.1" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1645 echo >> "$ABCDETEMPDIR/cddbchoices"
1649 case "$RESPONSECODE" in
1650 202) echo "No CDDB match." >> "$ABCDETEMPDIR/cddbchoices" ;;
1651 403|409) echo "CDDB entry is corrupt, or the handshake failed." >> "$ABCDETEMPDIR/cddbchoices" ;;
1652 503) echo "CDDB unavailable." >> "$ABCDETEMPDIR/cddbchoices" ;;
1654 $CDDBTOOL template $(cat "$ABCDETEMPDIR/discid") > "$ABCDETEMPDIR/cddbread.0"
1655 # List out disc title/author and contents of template
1656 echo ---- Unknown Artist / Unknown Album ---- >> "$ABCDETEMPDIR/cddbchoices"
1658 for TRACK in $(f_seq_row 1 $TRACKS)
1660 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.0" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1662 echo >> "$ABCDETEMPDIR/cddbchoices"
1663 echo cddb-read-0-complete >> "$ABCDETEMPDIR/status"
1664 echo cddb-choice=0 >> "$ABCDETEMPDIR/status"
1667 # Multiple exact, (possibly multiple) inexact matches
1669 if [ "$RESPONSECODE" = "211" ]; then IN=in; fi
1670 if [ "$(wc -l < "$ABCDETEMPDIR/cddbquery" | tr -d ' ')" -eq 3 ]; then
1671 echo "One ${IN}exact match:" >> "$ABCDETEMPDIR/cddbchoices"
1672 tail -n +2 "$ABCDETEMPDIR/cddbquery" | head -n 1 >> "$ABCDETEMPDIR/cddbchoices"
1673 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1675 echo "Multiple ${IN}exact matches:" >> "$ABCDETEMPDIR/cddbchoices"
1677 vecho -n "Retrieving multiple matches... "
1678 grep -v ^[.]$ "$ABCDETEMPDIR/cddbquery" | ( X=0
1679 read DISCINFO # eat top line
1683 if checkstatus cddb-read-$X-complete; then :; else
1684 $CDDBTOOL read $CDDBURL $CDDBPROTO $CDDBUSER $CDDBHOST $(echo $DISCINFO | cut -f1,2 -d' ') > "$ABCDETEMPDIR/cddbread.$X"
1685 echo cddb-read-$X-complete >> "$ABCDETEMPDIR/status"
1687 # List out disc title/author and contents
1688 echo \#$X: ---- "$DISCINFO" ---- >> "$ABCDETEMPDIR/cddbchoices"
1689 for TRACK in $(f_seq_row 1 $TRACKS)
1691 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.$X" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1693 echo >> "$ABCDETEMPDIR/cddbchoices"
1696 CDDBCHOICES=$(expr $(cat "$ABCDETEMPDIR/cddbquery" | wc -l) - 2)
1700 for TRACK in $(f_seq_row 1 $TRACKS)
1702 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.1" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1704 echo >> "$ABCDETEMPDIR/cddbchoices"
1705 echo cddb-read-1-complete >> "$ABCDETEMPDIR/status"
1706 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1709 echo "cddb-readcomplete" >> "$ABCDETEMPDIR/status"
1716 if checkstatus cddb-edit >/dev/null; then
1717 CDDBDATA="$ABCDETEMPDIR/cddbread.$(checkstatus cddb-choice)"
1718 VARIOUSARTISTS="$(checkstatus variousartists)"
1719 VARIOUSARTISTSTYLE="$(checkstatus variousartiststyle)"
1722 if [ "$INTERACTIVE" = "y" ]; then
1723 # We should show the CDDB results both when we are not using the local CDDB repo
1724 # or when we are using it but we could not find a proper match
1725 if [ "$CDDBUSELOCAL" = "y" ] && [ ! "$CDDBLOCALSUCCESS" = "y" ] || [ ! "$CDDBUSELOCAL" = "y" ]; then
1726 # Display the $ABCDETEMPDIR/cddbchoices file created above
1727 # Pick a pager so that if the tracks overflow the screen the user can still view everything
1728 if [ -r "$ABCDETEMPDIR/cddbchoices" ]; then
1729 CDDBCHOICES=$(expr $(cat "$ABCDETEMPDIR/cddbquery" | wc -l) - 2)
1730 CHOICE=$(checkstatus cddb-choice)
1731 if [ -n "$CHOICE" ] ; then
1732 case $CDDBCHOICES in
1733 1) cat "$ABCDETEMPDIR/cddbchoices" ;;
1735 echo "Selected: #$CHOICE"
1736 do_cddbparse "$ABCDETEMPDIR/cddbread.$CHOICE"
1740 # The user has a choice to make, display the info in a pager if necessary
1741 if [ $(cat "$ABCDETEMPDIR/cddbchoices" | wc -l) -ge 24 ]; then
1742 page "$ABCDETEMPDIR/cddbchoices"
1744 # It's all going to fit in one page, cat it
1745 cat "$ABCDETEMPDIR/cddbchoices" >&2
1749 # Setting the choice to an impossible integer to avoid errors in the numeric comparisons
1751 # I'll take CDDB read #3 for $400, Alex
1752 while [ $CDCHOICENUM -lt 0 ] || [ $CDCHOICENUM -gt $CDDBCHOICES ]; do
1753 echo -n "Which entry would you like abcde to use (0 for none)? [0-$CDDBCHOICES]: " >&2
1755 [ X"$CDDBCHOICE" = "X" ] && CDDBCHOICE=1
1756 if echo $CDDBCHOICE | egrep -q "[[:digit:]]+,[[:digit:]]+" ; then
1757 if [ ! X"$DIFF" = "X" ]; then
1758 PARSECHOICE1=$(echo $CDDBCHOICE | cut -d"," -f1)
1759 PARSECHOICE2=$(echo $CDDBCHOICE | cut -d"," -f2)
1760 if [ $PARSECHOICE1 -lt 1 ] || [ $PARSECHOICE1 -gt $CDDBCHOICES ] || \
1761 [ $PARSECHOICE2 -lt 1 ] || [ $PARSECHOICE2 -gt $CDDBCHOICES ] || \
1762 [ $PARSECHOICE1 -eq $PARSECHOICE2 ]; then
1763 echo "Invalid diff range. Please select two coma-separated numbers between 1 and $CDDBCHOICES" >&2
1766 # We parse the 2 choices to diff, store them in temporary files and diff them.
1767 for PARSECHOICE in $(echo $CDDBCHOICE | tr , \ ); do
1768 do_cddbparse "$ABCDETEMPDIR/cddbread.$PARSECHOICE" > "$ABCDETEMPDIR/cddbread.parsechoice.$PARSECHOICE"
1770 echo "Showing diff between choices $PARSECHOICE1 and $PARSECHOICE2..." > "$ABCDETEMPDIR/cddbread.diff"
1771 $DIFF $DIFFOPTS "$ABCDETEMPDIR/cddbread.parsechoice.$PARSECHOICE1" "$ABCDETEMPDIR/cddbread.parsechoice.$PARSECHOICE2" >> "$ABCDETEMPDIR/cddbread.diff"
1772 if [ $(cat "$ABCDETEMPDIR/cddbread.diff" | wc -l) -ge 24 ]; then
1773 page "$ABCDETEMPDIR/cddbread.diff"
1775 cat "$ABCDETEMPDIR/cddbread.diff" >&2
1779 echo "The diff program was not found in your path. Please choose a number between 0 and $CDDBCHOICES." >&2
1782 if [ $CDCHOICENUM -lt 0 ] || [ $CDCHOICENUM -gt $CDDBCHOICES ]; then
1783 # Make sure we get a valid choice
1784 CDCHOICENUM=$(echo $CDDBCHOICE | xargs printf %d 2>/dev/null)
1785 echo "Invalid selection. Please choose a number between 0 and $CDDBCHOICES." >&2
1789 if [ "$CDCHOICENUM" = "0" ]; then
1790 vecho "Creating empty CDDB template..."
1792 $CDDBTOOL template $(cat "$ABCDETEMPDIR/discid") > "$ABCDETEMPDIR/cddbread.0"
1794 echo "Selected: #$CDCHOICENUM ($(grep ^DTITLE= "$ABCDETEMPDIR/cddbread.$CDCHOICENUM" | cut -f2- -d= | tr -d \\r\\n))" >&2
1795 do_cddbparse "$ABCDETEMPDIR/cddbread.$CDCHOICENUM"
1797 echo "cddb-choice=$CDCHOICENUM" >> "$ABCDETEMPDIR/status"
1801 # We need some code to show the selected option when local repository is selected and we have found a match
1802 vecho "Using cached CDDB match..." >&2
1803 # Display the $ABCDETEMPDIR/cddbchoices file created above
1804 # Pick a pager so that if the tracks overflow the screen the user can still view everything
1805 if [ -r "$ABCDETEMPDIR/cddbchoices" ]; then
1806 CDDBCHOICES=$(expr $(cat "$ABCDETEMPDIR/cddbquery" | wc -l) - 2)
1807 CHOICE=$(checkstatus cddb-choice)
1808 if [ "$USELOCALRESP" = "y" ]; then :; else
1809 if [ -n "$CHOICE" ] ; then
1810 case $CDDBCHOICES in
1813 echo "Selected template."
1815 1) cat "$ABCDETEMPDIR/cddbchoices" ;;
1817 echo "Selected: #$CHOICE"
1818 do_cddbparse "$ABCDETEMPDIR/cddbread.$CHOICE"
1826 # We're noninteractive - pick the first choice.
1827 # But in case we run a previous instance and selected a choice, use it.
1828 if [ -r "$ABCDETEMPDIR/cddbchoices" ]; then
1829 # Show the choice if we are not using the locally stored one
1830 # or when the local search failed to find a match.
1831 PREVIOUSCHOICE=$(checkstatus cddb-choice)
1832 if [ "$CDDBUSELOCAL" = "y" ] && [ "$CDDBLOCALSUCCESS" = "n" ] || [ ! "$CDDBUSELOCAL" = "y" ]; then
1833 #if [ "$PREVIOUSCHOICE" ]; then
1834 cat "$ABCDETEMPDIR/cddbchoices"
1837 if [ ! -z "$PREVIOUSCHOICE" ] ; then
1838 CDCHOICENUM=$PREVIOUSCHOICE
1841 echo "cddb-choice=$CDCHOICENUM" >> "$ABCDETEMPDIR/status"
1843 echo "Selected: #$CDCHOICENUM ($(grep ^DTITLE= "$ABCDETEMPDIR/cddbread.$CDCHOICENUM" | cut -f2- -d= | tr -d \\r\\n))" >&2
1848 if checkstatus cddb-choice >/dev/null; then :; else
1849 echo "abcde: internal error: cddb-choice not recorded." >&2
1852 CDDBDATA="$ABCDETEMPDIR/cddbread.$(checkstatus cddb-choice)"
1853 echo -n "Edit selected CDDB data? [y/n] (" >&2
1854 if [ "$INTERACTIVE" = "y" ]; then
1855 if [ "$UNKNOWNDISK" = "y" ]; then
1858 [ "$EDITCDDB" != "n" ] && EDITCDDB=y
1867 if [ "$EDITCDDB" = "y" ]; then
1868 CDDBDATAMD5SUM=$($MD5SUM "$CDDBDATA" | cut -d " " -f 1);
1870 # Use the debian sensible-editor wrapper to pick the editor that the
1871 # user has requested via their $EDITOR environment variable
1872 if [ -x "/usr/bin/sensible-editor" ]; then
1873 /usr/bin/sensible-editor "$CDDBDATA"
1874 elif [ -n "$EDITOR" ]; then
1875 if [ -x $(which "${EDITOR%%\ *}") ]; then
1876 # That failed, try to load the preferred editor, starting
1877 # with their EDITOR variable
1878 eval $(echo "$EDITOR") \"$CDDBDATA\"
1880 # If that fails, check for a vi
1881 elif which vi >/dev/null 2>&1; then
1883 elif [ -x /usr/bin/vim ]; then
1884 /usr/bin/vim "$CDDBDATA"
1885 elif [ -x /usr/bin/vi ]; then
1886 /usr/bin/vi "$CDDBDATA"
1887 elif [ -x /bin/vi ]; then
1889 # nano should be on all (modern, i.e., sarge) debian systems
1890 elif which nano >/dev/null 2>&1 ; then
1892 elif [ -x /usr/bin/nano ]; then
1893 /usr/bin/nano "$CDDBDATA"
1894 # mg should be on all OpenBSD systems
1895 elif which mg >/dev/null 2>&1 ; then
1897 elif [ -x /usr/bin/mg ]; then
1898 /usr/bin/mg "$CDDBDATA"
1901 echo "No editor available. Check your EDITOR environment variable." >&2
1903 # delete editor backup file if it exists
1904 if [ -w "$CDDBDATA~" ]; then
1909 # Some heuristics first. Look at Disc Title, and if it starts with
1910 # "Various", then we'll assume Various Artists
1911 if [ "$(grep ^DTITLE= "$CDDBDATA" | cut -f2- -d= | egrep -ci '^(various|soundtrack|varios|sonora|ost)')" != "0" ]; then
1912 echo "Looks like a Multi-Artist CD" >&2
1915 echo -n "Is the CD multi-artist? [y/n] (n): " >&2
1916 if [ "$INTERACTIVE" = "y" ]; then
1923 if [ "$VARIOUSARTISTS" = "y" ] && [ ! "$ONETRACK" = "y" ]; then
1926 # Need NUMTRACKS before cddb-tool will return it:
1927 NUMTRACKS=$(egrep '^TTITLE[0-9]+=' "$CDDBDATA" | wc -l)
1928 if [ "$(grep -c "^TTITLE.*\/" "$CDDBDATA")" -gt "$(expr $NUMTRACKS / 2 )" ]; then
1929 # More than 1/2 tracks contain a "/", so guess forward
1931 elif [ "$(grep -c "^TTITLE.*\-" "$CDDBDATA")" -gt "$(expr $NUMTRACKS / 2 )" ]; then
1932 # More than 1/2 contain a "-", so guess forward-dash
1934 elif [ "$(grep -c "^TTITLE.*(.*)" "$CDDBDATA")" -gt "$(expr $NUMTRACKS / 2 )" ]; then
1935 # More than 1/2 contain something in parens, so guess trailing-paren
1939 echo "1) Artist / Title" >&2
1940 echo "2) Artist - Title" >&2
1941 echo "3) Title / Artist" >&2
1942 echo "4) Title - Artist" >&2
1943 echo "5) Artist: Title" >&2
1944 echo "6) Title (Artist)" >&2
1945 echo "7) This is a single-artist CD" >&2
1946 echo -n "Which style of multiple artist entries is it? [1-7] ($DEFAULTSTYLE): " >&2
1947 if [ "$INTERACTIVE" = "y" ]; then
1948 read VARIOUSARTISTSTYLE
1950 echo $DEFAULTSTYLE >&2
1951 VARIOUSARTISTSTYLE=$DEFAULTSTYLE
1953 VARIOUSARTISTSTYLE=$(echo 0$VARIOUSARTISTSTYLE | xargs printf %d)
1954 # If they press Enter, then the default style (0) was chosen
1955 while [ $VARIOUSARTISTSTYLE -lt 0 ] || [ $VARIOUSARTISTSTYLE -gt 7 ]; do
1956 echo "Invalid selection. Please choose a number between 1 and 7."
1957 echo -n "Selection [1-7]: "
1958 read VARIOUSARTISTSTYLE
1959 VARIOUSARTISTSTYLE=$(echo 0$VARIOUSARTISTSTYLE | xargs printf %d)
1961 if [ "$VARIOUSARTISTSTYLE" = "0" ]; then
1962 VARIOUSARTISTSTYLE=$DEFAULTSTYLE
1964 vecho "Selected: $VARIOUSARTISTSTYLE"
1965 case "$VARIOUSARTISTSTYLE" in
1967 VARIOUSARTISTSTYLE=forward
1970 VARIOUSARTISTSTYLE=forward-dash
1973 VARIOUSARTISTSTYLE=reverse
1976 VARIOUSARTISTSTYLE=reverse-dash
1979 VARIOUSARTISTSTYLE=colon
1982 VARIOUSARTISTSTYLE=trailing-paren
1990 echo "variousartists=$VARIOUSARTISTS" >> "$ABCDETEMPDIR/status"
1991 echo "variousartiststyle=$VARIOUSARTISTSTYLE" >> "$ABCDETEMPDIR/status"
1993 if [ "$EDITCDDB" = "y" ] && [ "$UNINTENTIONALLY_ANGER_THE_FREEDB_PEOPLE" = "y" ]; then
1994 if [ "$CDDBDATAMD5SUM" != "" ] && [ "$CDDBDATAMD5SUM" != "$($MD5SUM "$CDDBDATA" | cut -d " " -f 1)" ]; then
1995 # This works but does not have the necessary error checking
1996 # yet. If you are familiar with the CDDB spec
1997 # (see http://www.freedb.org/src/latest/DBFORMAT)
1998 # and can create an error-free entry on your own, then put
1999 # UNINTENTIONALLY_ANGER_THE_FREEDB_PEOPLE=y in your
2000 # abcde.conf to enable it. Put CDDBSUBMIT=email@address in
2001 # your abcde.conf to change the email address submissions are
2004 # submit the modified file, if they want
2005 if [ "$NOSUBMIT" != "y" ]; then
2006 echo -n "Do you want to submit this entry to $CDDBSUBMIT? [y/n] (n): "
2008 while [ "$YESNO" != "y" ] && [ "$YESNO" != "n" ] && [ "$YESNO" != "Y" ] && \
2009 [ "$YESNO" != "N" ] && [ "$YESNO" != "" ]
2011 echo -n 'Invalid selection. Please answer "y" or "n": '
2014 if [ "$YESNO" = "y" ] || [ "$YESNO" = "Y" ]; then
2015 echo -n "Sending..."
2016 $CDDBTOOL send "$CDDBDATA" $CDDBSUBMIT
2022 # Make sure the cache directory exists
2023 mkdir -p $CDDBLOCALDIR
2024 # Cache edited CDDB entry in the user's cddb dir
2025 if [ "$CDDBCOPYLOCAL" = "y" ] || [ "$COPYCDDBLOCAL" = "Y" ]; then
2026 cat "$CDDBDATA" | tail -n $(expr $(cat "$CDDBDATA" | wc -l ) - 1 ) > ${CDDBLOCALDIR}/$(echo "$TRACKINFO" | cut -d' ' -f1)
2029 echo "cddb-edit" >> "$ABCDETEMPDIR/status"
2032 # do_cdread [tracknumber]
2033 # do_cdread onetrack [firsttrack] [lasttrack]
2037 # The commands here don't go through run_command because they're never supposed to be silenced
2038 # return codes need to be doublechecked anyway, however
2039 if [ "$1" = "onetrack" ]; then
2040 # FIXME # Add the possibility of grabbing ranges of tracks in onetrack
2041 # FIXME # Until then, we grab the whole CD in one track, no matter what
2043 # We need the first and last track for cdda2wav
2046 UTRACKNUM=$FIRSTTRACK
2047 case "$CDROMREADERSYNTAX" in
2048 cdparanoia) READTRACKNUMS="$FIRSTTRACK-$LASTTRACK" ;;
2049 cdda2wav) READTRACKNUMS="$FIRSTTRACK+$LASTRACK" ;;
2050 *) echo "abcde error: $CDROMREADERSYNTAX does not support ONETRACK mode"
2056 CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
2057 if [ "$USEPIPES" = "y" ]; then
2058 TEMPARG="PIPE_$CDROMREADERSYNTAX"
2059 FILEARG="$( eval echo "\$$TEMPARG" )"
2061 PIPE_MESSAGE="and encoding "
2063 WAVDATA="$ABCDETEMPDIR/track$UTRACKNUM.wav"
2064 case "$CDROMREADERSYNTAX" in
2065 ## FIXME ## Find the case for dagrab, to avoid exceptions
2067 FILEARG="-f $WAVDATA"
2075 if [ "$1" = "onetrack" ]; then
2076 echo "Grabbing ${PIPE_MESSAGE}tracks $UTRACKNUM - $LASTTRACK as one track ..." >&2
2078 if [ -r "$CDDBDATA" ]; then
2079 #TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | head -n 1 | cut -f2 -d= | tr -d \[:cntrl:\])
2080 do_getcddbinfo TRACKNAME
2081 echo "Grabbing ${PIPE_MESSAGE}track $UTRACKNUM: $TRACKNAME..." >&2
2083 echo "Grabbing ${PIPE_MESSAGE}track $UTRACKNUM..." >&2
2086 case "$CDROMREADERSYNTAX" in
2088 nice $READNICE $CDROMREADER -$CDPARANOIACDROMBUS $CDROM ${READTRACKNUMS:-$UTRACKNUM} "$FILEARG" $REDIR ;;
2090 if [ "$OSFLAVOUR" = "OSX" ] ; then
2091 # Hei, we have to unmount the device before running anything like cdda2wav in OSX
2092 disktool -u ${CDROM#/dev/} 0
2093 # Also, in OSX the cdrom device for cdda2wav changes...
2094 CDDA2WAVCDROM="IODVDServices"
2095 elif [ "$OSFLAVOUR" = "FBSD" ] ; then
2096 CDDA2WAVCDROM="$CDROMID"
2098 if [ "$CDROMID" = "" ]; then
2099 CDDA2WAVCDROM="$CDROM"
2101 CDDA2WAVCDROM="$CDROMID"
2104 nice $READNICE $CDROMREADER -D $CDDA2WAVCDROM -t ${READTRACKNUMS:-$UTRACKNUM} "$FILEARG" $REDIR
2106 ## FIXME ## We have an exception for dagrab, since it uses -f
2107 ## FIXME ## Shall we just use -f $FILEARG ??
2108 dagrab) nice $READNICE $CDROMREADER -d $CDROM -v $UTRACKNUM "$FILEARG" $REDIR
2111 # Find the track's mounted path
2112 REALTRACKNUM=$(expr $UTRACKNUM + 0)
2113 FILEPATH=$(mount | grep "$CDROM on" | sed 's/^[^ ]* on \(.*\) (.*/\1/')
2114 FILEPATH=$(find "$FILEPATH" | grep "/$REALTRACKNUM ");
2115 # If the file exists, copy it
2116 if [ -e "$FILEPATH" ] ; then
2117 nice $READNICE $CDROMREADER "$FILEPATH" "$FILEARG" $REDIR
2121 debug) nice $READNICE $CDROMREADER -$CDPARANOIACDROMBUS $CDROM -w $UTRACKNUM-[:1] "$FILEARG" $REDIR
2125 # If we get some error or we get some missing wav
2126 # (as long as we dont use pipes)
2127 if [ "$RETURN" != "0" -o \( ! -s "$WAVDATA" -a X"$USEPIPES" != "Xy" \) ]; then
2128 # Thank goodness errors is only machine-parseable up to the
2129 # first colon, otherwise this woulda sucked
2130 if [ "$RETURN" = "0" -a ! -s "$WAVDATA" ]; then
2131 RETURN=73 # fake a return code as cdparanoia return 0 also on aborted reads
2133 if [ "$USEPIPES" = "y" ]; then
2134 echo "readencodetrack-$UTRACKNUM: $CDROMREADER returned code $RETURN" >> "$ABCDETEMPDIR/errors"
2136 echo "readtrack-$UTRACKNUM: $CDROMREADER returned code $RETURN" >> "$ABCDETEMPDIR/errors"
2140 if [ "$USEPIPES" = "y" ]; then
2141 echo readencodetrack-$UTRACKNUM >> "$ABCDETEMPDIR/status"
2143 echo readtrack-$UTRACKNUM >> "$ABCDETEMPDIR/status"
2144 if [ "$1" = "onetrack" ]; then
2145 echo onetrack >> "$ABCDETEMPDIR/status"
2152 # No values accepted, only uses env variables
2155 if "$CDSPEED" "$CDSPEEDOPTS" "$CDSPEEDVALUE" >/dev/null ; then
2156 vecho "Setting CD speed to ${CDSPEEDVALUE}x"
2158 echo "abcde: unable to set the device speed" >&2
2164 # vecho outputs a message if EXTRAVERBOSE is selected
2167 if [ x"$EXTRAVERBOSE" != "x" ]; then
2172 # User-redefinable functions
2173 # Custom filename munging:
2176 #echo "$@" | sed s,:,\ -,g | tr \ /\* __+ | tr -d \'\"\?\[:cntrl:\]
2177 echo "$@" | sed s,:,\ -,g | tr \ / __ | tr -d \'\"\?\[:cntrl:\]
2180 # Custom genre munging:
2183 echo $CDGENRE | tr "[:upper:]" "[:lower:]"
2187 # Empty pre_read function, to be defined in the configuration file.
2194 # Empty post_read function, to be defined in the configuration file.
2200 ###############################################################################
2203 # Start of execution
2204 ###############################################################################
2207 CDDBURL="http://freedb.freedb.org/~cddb/cddb.cgi"
2208 CDDBSUBMIT=freedb-submit@freedb.org
2210 HELLOINFO="$(whoami)@$(hostname)"
2212 CDDBLOCALDIR="$HOME/.cddb"
2215 # List of fields we parse and show during the CDDB parsing...
2216 SHOWCDDBFIELDS="year,genre"
2219 CDROMREADERSYNTAX=cdparanoia
2220 ENCODERSYNTAX=default
2222 MP3ENCODERSYNTAX=default
2223 OGGENCODERSYNTAX=default
2224 FLACENCODERSYNTAX=default
2225 SPEEXENCODERSYNTAX=default
2226 MPPENCODERSYNTAX=default
2227 NORMALIZERSYNTAX=default
2228 CUEREADERSYNTAX=default
2230 OUTPUTFORMAT='${ARTISTFILE}-${ALBUMFILE}/${TRACKNUM}.${TRACKFILE}'
2231 # Use the following VAOUTPUTFORMAT to revert to 2.0.x VA format:
2232 #VAOUTPUTFORMAT=${OUTPUTFORMAT}
2233 VAOUTPUTFORMAT='Various-${ALBUMFILE}/${TRACKNUM}.${ARTISTFILE}-${TRACKFILE}'
2234 ONETRACKOUTPUTFORMAT='${ARTISTFILE}-${ALBUMFILE}/${ALBUMFILE}'
2235 VAONETRACKOUTPUTFORMAT='Various-${ALBUMFILE}/${ALBUMFILE}'
2236 PLAYLISTFORMAT='${ARTISTFILE}-${ALBUMFILE}.${OUTPUT}.m3u'
2237 PLAYLISTDATAPREFIX=''
2238 VAPLAYLISTFORMAT='${ARTISTFILE}-${ALBUMFILE}.${OUTPUT}.m3u'
2239 VAPLAYLISTDATAPREFIX=''
2247 VARIOUSARTISTSTYLE=forward
2251 # If using scsi devices, cdda2wav needs a CDROMID, instead of a device node
2252 # i.e. CDROMID="1,0,0"
2254 # If we are using the IDE bus, we need CDPARANOIACDROMBUS defined as "d"
2255 # If we are using the ide-scsi emulation layer, we need to define a "g"
2256 CDPARANOIACDROMBUS="d"
2258 # program paths - defaults to checking your $PATH
2264 XINGMP3ENC=xingmp3enc
2279 CDPARANOIA=cdparanoia
2288 VORBISCOMMENT=vorbiscomment
2290 NORMALIZE=normalize-audio
2292 VORBISGAIN=vorbisgain
2297 # Options for programs called from abcde
2329 VORBISCOMMENTOPTS="-R"
2330 METAFLACOPTS="--no-utf8-convert"
2332 # Default to one process if -j isn't specified
2335 # List of actions to perform - by default, run to completion
2336 ACTIONS=cddb,read,encode,tag,move,clean
2338 # List of prefered outputs - by default, run with whatever we have in the path
2339 # This option is basicaly for Debian package dependencies
2340 DEFAULT_OUTPUT_BINARIES=vorbis:oggenc,flac:flac,mp3:lame,mp3:bladeenc,spx:speex
2342 # Asume fetch if under FreeBSD. curl is used for Mac OS X. wget is used for Linux/OpenBSD/NetBSD.
2343 # Let's use these checkings to determine the OS flavour, which will be used later
2344 if [ X$(uname) = "XFreeBSD" ] ; then
2349 elif [ X$(uname) = "XDarwin" ] ; then
2352 # We should have disktool in OSX, but let's be sure...
2354 CDROMREADERSYNTAX=cddafs
2355 elif [ X$(uname) = "XOpenBSD" ] ; then
2358 elif [ X$(uname) = "XNetBSD" ] ; then
2365 # If CDDBAVAIL is set to n, no CDDB read is done
2366 # If USEID3 is set to n, no ID3 tagging is done
2371 if [ -z "$OUTPUTDIR" ]; then
2375 if [ -z "$WAVOUTPUTDIR" ]; then
2376 WAVOUTPUTDIR="$OUTPUTDIR"
2379 # Load system defaults
2380 if [ -r /etc/abcde.conf ]; then
2383 # Load user preference defaults
2384 if [ -r $HOME/.abcde.conf ]; then
2388 # By this time, we need some HTTPGETOPTS already defined.
2389 # If the user has defined a non-default HTTPGET method, we should not be empty.
2391 if [ "$HTTPGETOPTS" = "" ] ; then
2393 wget) HTTPGETOPTS="-q -O -";;
2394 curl) HTTPGETOPTS="-f -s";;
2395 fetch)HTTPGETOPTS="-q -o -";;
2396 ftp) HTTPGETOPTS="-q -o -";;
2397 *) echo "abcde warning: HTTPGET in non-standard and HTTPGETOPTS are not defined." >&2 ;;
2401 # If the CDROM has not been set yet, find a suitable one.
2402 # If this is a devfs system, default to /dev/cdroms/cdrom0
2403 # instead of /dev/cdrom
2404 if [ "$CDROM" = "" ] ; then
2405 if [ -e /dev/cdroms/cdrom0 ]; then
2406 CDROM=/dev/cdroms/cdrom0
2407 elif [ -e /dev/cdrom ]; then
2409 elif [ -e /dev/cd0c ]; then
2411 elif [ -e /dev/acd0c ]; then
2413 elif [ -e /dev/disk1 ]; then
2418 # Parse command line options
2419 #while getopts 1a:A:bc:C:d:Dehj:klLmMnNo:pPr:Rs:S:t:T:vVxw:W: opt ; do
2420 while getopts 1a:bc:C:d:Dehj:klLmMnNo:pPr:Rs:S:t:T:vVxw:W: opt ; do
2423 a) ACTIONS="$OPTARG" ;;
2424 A) EXPACTIONS="$OPTARG" ;;
2426 c) if [ -e "$OPTARG" ] ; then . "$OPTARG" ; else echo "abcde error: config file \"$OPTARG\" cannot be found." >&2 ; exit 1 ; fi ;;
2427 C) DISCID="${OPTARG#abcde.}" ;;
2428 d) CDROM="$OPTARG" ;;
2430 e) ERASEENCODEDSTATUS=y ;;
2432 e) ERASEENCODEDSTATUS=y ;;
2433 E) ENCODING="$OPTARG" ;;
2434 # f) FORCECDDBUSELOCAL=y ;;
2436 j) MAXPROCS="$OPTARG" ;;
2439 L) CDDBUSELOCAL=y ;;
2444 o) OUTPUTTYPE="$OPTARG" ;;
2447 r) REMOTEHOSTS="$OPTARG" ;;
2449 s) SHOWCDDBFIELDS="$OPTARG" ;;
2450 S) CDSPEEDVALUE="$OPTARG" ;;
2451 # t) PREPROCESSFORMATS="$OPTARG"
2453 # T) POSTPROCESSFORMATS="$OPTARG" ;;
2454 t) STARTTRACKNUMBER="$OPTARG" ;;
2455 T) STARTTRACKNUMBER="$OPTARG" ; STARTTRACKNUMBERTAG="y" ;;
2457 echo "This is abcde v$VERSION."
2458 echo "Usage: abcde [options] [tracks]"
2459 echo "abcde -h for extra help"
2462 V) EXTRAVERBOSE="y" ;;
2464 w) COMMENT="$OPTARG" ;;
2465 W) if echo $OPTARG | grep -q "[[:digit:]]" ; then
2466 STARTTRACKNUMBER="${OPTARG}01" ; STARTTRACKNUMBERTAG="y" ; COMMENT="CD${OPTARG}"
2468 echo "abcde error: argument of -W must be integer"
2476 shift $(($OPTIND - 1))
2478 # Decide if we can continue.
2479 if [ "$ONETRACK" = "y" ]; then
2480 # FIXME # remove check as soon as we find out about the other readers
2481 case "$CDROMREADERSYNTAX" in
2484 *) echo "abcde error: $CDROMREADERSYNTAX does not support ONETRACK mode"
2487 if [ "$BATCH" = "y" ]; then
2488 echo "abcde error: BATCH mode is not compatible with ONETRACK mode"
2491 # It does not matter how many tracks we want. In ONETRACK mode we grab them all
2492 # FIXME # allow ranges of tracks to be selected for onetrack ripping
2493 if [ $# -gt 0 ]; then
2494 vecho "abcde warning: ONETRACK mode selected, grabbing all tracks..."
2497 while [ $# -gt 0 ]; do
2498 # Range parsing code courtesy of Vincent Ho
2499 RSTART=$(echo $1 | cut -f1 -d-)
2500 REND=$(echo $1 | cut -f2 -d-)
2501 if [ "$RSTART" = "$REND" ]; then
2504 NEWTRACKS=$(f_seq_line $RSTART $REND)
2506 TRACKQUEUE=$(echo "$TRACKQUEUE" "$NEWTRACKS")
2511 # List of valid actions: cddb,read,normalize,encode,tag,move,playlist,clean
2512 # List of experimental actions: retag,transcode
2514 # Determine what actions are to be done from $ACTIONS and set the
2515 # following environment variables for them:
2528 for ACTION in $(echo $ACTIONS | tr , \ )
2533 normalize) DONORMALIZE=y; DOREAD=y;;
2534 # preprocess) DOPREPROCESS=y; DOREAD=y;;
2535 encode) DOENCODE=y; DOREAD=y;;
2536 # postprocess) DOPREPROCESS=y; DOENCODE=y; DOREAD=y;;
2537 tag) DOTAG=y; DOREAD=y; DOENCODE=y; DOCDDB=y;;
2538 move) DOMOVE=y; DOTAG=y; DOREAD=y; DOENCODE=y; DOCDDB=y;;
2539 replaygain) DOCDDB=y; DOREAD=y; DOENCODE=y; DOTAG=y; DOMOVE=y; DOREPLAYGAIN=y;;
2540 playlist) DOCDDB=y; DOPLAYLIST=y;;
2545 if [ "$DONORMALIZE" = "y" ] && [ "$DOREPLAYGAIN" = "y" ]; then
2546 # FIXME # should we abort on error or just inform the user?
2550 for SHOWCDDBFIELD in $(echo $SHOWCDDBFIELDS | tr , \ ); do
2551 case $SHOWCDDBFIELD in
2552 y*|Y*) SHOWCDDBYEAR="y";;
2553 g*|G*) SHOWCDDBGENRE="y";;
2560 # At this point a CDROM has to be defined, so we check it exists.
2561 if [ X"$CDROM" != "X" ] ; then
2562 if [ "$CDROMREADERSYNTAX" = "cdda2wav" ] && [ "$NEEDCDROMID" = "y" ] ; then
2563 if [ "$OSFLAVOUR" = "FBSD" ]; then
2564 if ! echo "$CDROMID" | grep "^[0-9],[0-9],[0-9]$" >/dev/null 2>&1 ; then
2565 echo "abcde error: CDROMID not in the right format for $CDROMREADERSYNTAX"
2566 echo "Use \"cdrecord -scanbus\" to obtain a adecuate ID an set CDROMID accordingly"
2570 elif [ ! -e "$CDROM" -a X"$DOREAD" = "Xy" ]; then
2571 echo "abcde error: CDROM device cannot be found." >&2
2574 # avoid processing if we are not going to hit the CDROM.
2575 elif [ X"$DOREAD" = "Xy" ]; then
2576 echo "abcde error: CDROM has not been defined or cannot be found" >&2
2580 # USEPIPES pre-tests, before we get into more serious stuff
2581 # Not compatible with:
2582 # - multiple outputs
2584 # - lowdisk algorithm
2586 if [ X"$USEPIPES" = "Xy" ]; then
2587 if [ $(echo "$OUTPUTTYPE" | tr , \ | wc -w ) -gt 1 ]; then
2588 echo "abcde error: Unix pipes not compatible with multiple outputs" >&2
2591 if [ X"$DONORMALIZE" = "Xy" ]; then
2592 echo "abcde error: Unix pipes not compatible with normalizer"
2593 # FIXME # Do we need to exit or shall we just disable the mode?
2596 if [ X"$DOENCODE" = "Xn" ]; then
2597 vecho "Disabling Unix pipes since we are not encoding!"
2600 if [ X"$LOWDISK" = "Xy" ]; then
2601 vecho "abcde error: Unix pipes not compatible with lowdisk algorithm"
2606 # Check the encoding format from the ones available in the system, if nothing has been configured in the system.
2607 if [ X"$OUTPUTTYPE" = "X" ]; then
2608 for DEFAULT_OUTPUT in $( echo "$DEFAULT_OUTPUT_BINARIES" | tr , \ ); do
2609 DEFAULT_OUTPUT_FORMAT="$(echo $DEFAULT_OUTPUT | cut -d ":" -f 1)"
2610 DEFAULT_OUTPUT_BINARY="$(echo $DEFAULT_OUTPUT | cut -d ":" -f 2)"
2611 if [ -x $(which $DEFAULT_OUTPUT_BINARY) ] ; then
2612 OUTPUTTYPE=$DEFAULT_OUTPUT_FORMAT
2613 vecho "No default output type defined. Autoselecting $OUTPUTTYPE..." >&2
2617 if [ X"$OUTPUTTYPE" = "X" ]; then
2618 echo "abcde error: no encoder found in the PATH" >&2
2619 echo "hits: are all dependencies installed? has the \$PATH been modified?" >&2
2624 # Decide which CDROM reader we're gonna use
2625 case "$CDROMREADERSYNTAX" in
2627 CDROMREADER="$CDPARANOIA"
2628 CDROMREADEROPTS="$CDPARANOIAOPTS"
2631 CDROMREADER="$CDDA2WAV"
2632 CDROMREADEROPTS="$CDDA2WAVOPTS"
2635 CDROMREADER="$DAGRAB"
2636 CDROMREADEROPTS="$DAGRABOPTS"
2639 CDROMREADER="$CDDAFS"
2640 CDROMREADEROPTS="$CDDAFSOPTS"
2644 # There's only one normalize...
2645 case "$NORMALIZERSYNTAX" in
2647 NORMALIZER="$NORMALIZE"
2648 NORMALIZEROPTS="$NORMALIZEOPTS"
2652 # Allow -o OUTPUT(1):OPTIONS(1),...,OUTPUT(N):OPTIONS(N) mode of operation
2653 if echo "$OUTPUTTYPE" | grep ":" > /dev/null 2>&1 ; then
2654 for OUTPUT in "$(echo "$OUTPUTTYPE" | tr , \ )"; do
2656 vorbis:*|ogg:*) OGGENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2657 mp3:*) MP3ENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2658 flac:*) FLACENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2659 spx:*) SPEEXENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2660 mpc:*) MPPENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2663 for OUTPUT in "$(echo "$OUTPUTTYPE" | tr , \ )"; do
2664 TEMPOUTPUT=$( echo "$OUTPUT" | cut -d: -f1 )
2665 TEMPOUTPUTTYPE="${TEMPOUTPUTTYPE:+$TEMPOUTPUTTYPE,}$TEMPOUTPUT"
2667 OUTPUTTYPE="$TEMPOUTPUTTYPE"
2670 # If nothing has been specified, use oggenc for oggs and lame for mp3s and flac for flacs and speexenc for speex and mppenc for mpps
2672 # Getting ready for multiple output changes
2673 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
2677 [ "$OGGENCODERSYNTAX" = "default" ] && OGGENCODERSYNTAX=oggenc
2678 [ "$DOTAG" = "y" ] && NEEDCOMMENTER=y
2679 [ "$REPLAYGAIN" = "y" ] && NEEDVORBISGAIN=y
2680 OGGOUTPUTCONTAINER=ogg
2683 [ "$MP3ENCODERSYNTAX" = "default" ] && MP3ENCODERSYNTAX=lame
2684 [ "$DOTAG" = "y" ] && NEEDTAGGER=y
2687 [ "$FLACENCODERSYNTAX" = "default" ] && FLACENCODERSYNTAX=flac
2688 [ "$DOTAG" = "y" ] && NEEDMETAFLAC=y
2691 [ "$SPEEXENCODERSYNTAX" = "default" ] && SPEEXENCODERSYNTAX=speexenc
2694 [ "$MPPENCODERSYNTAX" = "default" ] && MPPENCODERSYNTAX=mppenc
2696 *) echo "abcde error: Invalid OUTPUTTYPE defined" >&2
2702 # decide which encoder
2703 case "$MP3ENCODERSYNTAX" in
2705 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$LAMEOPTS}"
2709 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$GOGOOPTS}"
2713 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$BLADEENCOPTS}"
2714 MP3ENCODER="$BLADEENC"
2717 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$L3ENCOPTS}"
2721 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$XINGMP3ENCOPTS}"
2722 MP3ENCODER="$XINGMP3ENC"
2725 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$MP3ENCOPTS}"
2726 MP3ENCODER="$MP3ENC"
2729 case "$OGGENCODERSYNTAX" in
2731 OGGENCODEROPTS="${OGGENCODEROPTSCLI:-$VORBIZEOPTS}"
2732 OGGENCODER="$VORBIZE"
2735 OGGENCODEROPTS="${OGGENCODEROPTSCLI:-$OGGENCOPTS}"
2736 OGGENCODER="$OGGENC"
2739 case "$FLACENCODERSYNTAX" in
2741 FLACENCODEROPTS="${FLACENCODEROPTSCLI:-$FLACOPTS}"
2743 # FLAC streams can be encapsulated on a Ogg transport layer
2744 if echo "$FLACENCODEROPTS" | egrep -q -- "(^| )--ogg($| )" ;then
2745 echo "abcde error: FLAC on an Ogg container is not yet supported" >&2
2746 echo " due to problem with adding comments to such files" >&2
2748 FLACOUTPUTCONTAINER=ogg
2750 FLACOUTPUTCONTAINER=flac
2754 case "$SPEEXENCODERSYNTAX" in
2756 SPEEXENCODEROPTS="${SPEEXENCODEROPTSCLI:-$SPEEXENCOPTS}"
2757 SPEEXENCODER="$SPEEXENC"
2760 case "$MPPENCODERSYNTAX" in
2762 MPPENCODEROPTS="${MPPENCODEROPTSCLI:-$MPPENCOPTS}"
2763 MPPENCODER="$MPPENC"
2769 if [ "$ID3TAGV" = "1" ]; then
2771 TAGGEROPTS="$ID3OPTS"
2774 TAGGEROPTS="$ID3V2OPTS"
2778 case "$CUEREADERSYNTAX" in
2780 CUEREADEROPTS="${CDROM}"
2785 # Check if both OGGEOUTPUTCONTAINER and FLACOUTPUTCONTAINER are the same, and differentiante them
2786 if [ X"$OGGOUTPUTCONTAINER" = "Xogg" ] && [ X"$FLACOUTPUTCONTAINER" = "Xogg" ]; then
2787 echo "abcde error: FLAC on an Ogg container is not yet supported" >&2
2788 echo " due to problem with adding comments to such files" >&2
2790 OGGOUTPUTCONTAINER=ogg.ogg
2791 FLACOUTPUTCONTAINER=flac.ogg
2792 vecho "abcde warning: modified file endings due to conflicting transport layers in Ogg/Vorbis and Ogg/FLAC"
2795 # Clean up nice options (either use '-n NICELEVEL or -NICELEVEL')
2797 if [ "$ENCNICE" ]; then
2798 ENCNICE="-n $ENCNICE"
2800 if [ "$READNICE" ]; then
2801 READNICE="-n $READNICE"
2803 if [ "$DISTMP3NICE" ]; then
2804 DISTMP3NICE="-n $DISTMP3NICE"
2807 # Don't check for stuff if it's not needed
2808 if [ "$REMOTEHOSTS" ]; then
2811 if [ "$DONORMALIZE" = "y" ]; then
2814 if [ "$EJECTCD" = "y" ]; then
2817 if [ ! "$CDDBAVAIL" = "n" ] && [ "$DOCDDB" = "y" ]; then
2820 if [ "$MAKECUEFILE" = "y" ]; then
2824 if [ X"$CDSPEEDVALUE" != "X" ]; then
2825 case "$CDROMREADERSYNTAX" in
2826 cdparanoia|debug) CDROMREADEROPTS="$CDPARANOIAOPTS -S $CDSPEEDVALUE" ;;
2831 # Rippers with USEPIPE support
2832 # FIXME # Include here all the rippers we can figure out support pipes
2835 # Encoders with USEPIPE support
2836 # FIXME # Include here all the encoders we can figure out support pipes
2841 # Figure out if we can use pipes with the ripper/encoder combination
2843 if [ "$USEPIPES" = "y" ]; then
2844 PIPERIPPERSVARCHECK="PIPE_${CDROMREADER}"
2847 PIPEENCODERSVARCHECK="PIPE_$MP3ENCODERSYNTAX" ;;
2849 PIPEENCODERSVARCHECK="PIPE_$OGGENCODERSYNTAX" ;;
2851 PIPEENCODERSVARCHECK="PIPE_$FLACENCODERSYNTAX" ;;
2853 PIPEENCODERSVARCHECK="PIPE_$SPEEXENCODER" ;;
2855 PIPEENCODERSVARCHECK="PIPE_$MPPENCODER" ;;
2857 if [ ! -n "$( eval echo "\$$PIPERIPPERSVARCHECK" )" ] ; then
2858 echo "abcde error: no support for pipes with given ripper" >&2
2859 echo "read the USEPIPES file from the source tarball to help" >&2
2860 echo "on a Debian system, read /usr/share/doc/abcde/USEPIPES.gz" >&2
2863 if [ ! -n "$( eval echo "\$$PIPEENCODERSVARCHECK" )" ] ; then
2864 echo "abcde error: no support for pipes with given encoder" >&2
2865 echo "read the USEPIPES file from the source tarball to help" >&2
2866 echo "on a Debian system, read /usr/share/doc/abcde/USEPIPES.gz" >&2
2871 # Make sure a buncha things exist
2872 for X in $CDROMREADER $CDDISCID ${NEEDTAGGER+$TAGGER} $MP3ENCODER \
2873 $OGGENCODER $FLACENCODER $SPEEXENCODER $MPPENCODER \
2874 ${NEEDHTTPGET+$HTTPGET} ${NEEDDISTMP3+$DISTMP3} \
2875 ${NEEDCOMMENTER+$VORBISCOMMENT} ${NEEDMETAFLAC+$METAFLAC} \
2876 ${NEEDNORMALIZER+$NORMALIZER} ${NEEDEJECT+$EJECT} \
2877 ${NEEDDISKTOOL+disktool} ${NEEDCDSPEED+$CDSPEED} \
2878 ${NEEDVORBISGAIN+$VORBISGAIN} ${NEEDCUEREADER+$CUEREADER}
2880 # Cut off the command-line options we just added in
2881 X=$(echo $X | cut -d' ' -f2)
2882 if [ "$(which $X)" = "" ]; then
2883 echo "abcde error: $X is not in your path." >&2
2885 elif [ ! -x $(which $X) ]; then
2886 echo "abcde error: $X is not executable." >&2
2891 CDROMREADER="$CDROMREADER $CDROMREADEROPTS"
2892 CDDBTOOL="$CDDBTOOL $CDDBTOOLOPTS"
2893 HTTPGET="$HTTPGET $HTTPGETOPTS"
2895 # And last but not least, check if we can diff between files
2896 if [ -x $(which $DIFF) ]; then :; else
2897 vecho "[WAR] Disabling diff since we cannot find it in the \$PATH..."
2901 # Here it used to say:
2902 # One thousand lines in, we can start doing stuff with things
2903 # Well, right now we are at line 2736 ;)
2905 # Export needed things so they can be read in this subshell
2906 export CDDBTOOL ABCDETEMPDIR TRACKQUEUE LOWDISK EJECTCD EJECT EJECTOPTS
2907 export CDROM CDDBDATA REMOTEHOSTS MAXPROCS HTTPGET MD5SUM
2909 # User-definable function to set some things. Use it for
2910 # - closing the CD tray with eject -t
2911 # - set the CD speed value with eject -x
2912 vecho -n "Executing customizable pre-read function... "
2914 pre_read # Execute the user-defined pre-read funtion. Close the CD with it.
2918 do_discid # Get ABCDETEMPDIR created and status file initialized
2920 if [ "$DOCDDB" = "y" ]; then
2921 if [ $CDDBUSELOCAL = "y" ]; then
2924 if checkstatus cddb-choice > /dev/null; then
2927 if [ ! "$CDDBLOCALSUCCESS" = "y" ] ; then
2935 eval "$($CDDBTOOL parse "$CDDBDATA")"
2938 # Before reading tracks, we set the speed of the device
2940 if [ X"$CDSPEEDVALUE" != "X" ]; then
2941 case "$CDROMREADERSYNTAX" in
2942 cdparanoia|debug) : ;;
2947 # Define the first and last track, since we might need them later in several places
2948 FIRSTTRACK=$( get_first $TRACKQUEUE )
2949 LASTTRACK=$( get_last $TRACKQUEUE )
2951 if [ -f "$ABCDETEMPDIR/status" ] && [ X"$ERASEENCODEDSTATUS" = "Xy" ]; then
2952 mv "$ABCDETEMPDIR/status" "$ABCDETEMPDIR/status.old"
2953 grep -v ^encodetracklocation- < "$ABCDETEMPDIR/status.old" \
2954 | grep -v ^encode-output > "$ABCDETEMPDIR/status"
2957 # Create playlist if needed (backgroundable) and start reading in tracks
2961 if [ ! "$ONETRACK" = "y" ]; then
2962 if [ "$DOPLAYLIST" = "y" ]; then
2963 echo Creating playlist... >&2
2968 # For the lowdisk option, only one program is running at once so the encoder
2969 # can be unsilenced right away.
2970 if [ "$LOWDISK" = "y" ] || [ "$ONETRACK" = "y" ]; then
2971 echo "encode-output=loud" >> "$ABCDETEMPDIR/status"
2974 if [ "$ONETRACK" = "y" ]; then
2975 TRACKS="$FIRSTTRACK"
2976 if checkstatus readtrack-$FIRSTTRACK; then :; else
2977 do_cdread onetrack $FIRSTTRACK $LASTTRACK
2980 for UTRACKNUM in $TRACKQUEUE
2982 if [ "$DOREAD" = "y" ]; then
2983 if [ "$USEPIPES" = "y" ]; then
2984 if checkstatus readencodetrack-$UTRACKNUM; then :; else
2985 # Read, pipe, shut up!
2986 do_cdread $UTRACKNUM | do_encode $UTRACKNUM %local0% > /dev/null 2>&1
2989 if checkstatus readtrack-$UTRACKNUM; then :; else
2990 do_cdread $UTRACKNUM
2992 if [ "$?" != "0" ]; then
2993 # CD read failed - don't give the goahead to
3000 if [ "$BATCH" = "y" ]; then
3003 echo NEXTTRACK # Get the encoder machine churning again
3004 if [ "$DOREAD" = "y" ]; then
3005 if [ "$LOWDISK" = "y" ] && [ "$DOENCODE" = "y" ]; then
3006 until checkstatus encodetrack-$UTRACKNUM
3008 if checkerrors encodetrack-$UTRACKNUM; then
3019 # Now that we're done the encoding can be loud again -
3020 # if we're not using SMP.
3021 if [ "$MAXPROCS" = "1" ]; then
3022 echo "encode-output=loud" >> "$ABCDETEMPDIR/status"
3025 # All tracks read, start encoding.
3026 if [ "$BATCH" = "y" ] || [ "$ONETRACK" = "y" ]; then
3030 # Execute the user-defined post_read funtion before ejecting CD
3033 # We are now finished with the cdrom - it can be safely ejected. Note that
3034 # abcde will not have completed yet.
3035 if [ "$EJECTCD" = "y" ] && [ -x $(which $EJECT) ]; then
3036 # We check if the disk we are processing is actually the disk inside the
3037 # CD tray. If not, we do not eject the CD, since it might be so that the
3038 # user ejected it manually.
3039 #CURRENTTRACKINFO=$($CDDISCID $CDROM)
3040 #if if [ "$?" != "1" ] && [ "$CURRENTTRACKINFO" = "$TRACKINFO" ] ; then
3041 # More FreeBSD bits.
3042 if [ X"$(uname)" = X"FreeBSD" ] ; then
3043 # FreeBSD eject uses the EJECT environment variable to name the CDROM
3044 # but in this script EJECT is in the envionment and names the program
3047 # The FreeBSD eject needs "adc0" not "/dev/adc0c"
3048 cd="$(echo $CDROM | sed -e 's=.*/==;s=[a-h]$==;')"
3049 $eject $EJECTOPTS $cd
3050 elif [ X"$(uname)" = X"Darwin" ] ; then
3051 disktool -e ${CDROM#/dev/} 0
3053 $EJECT $EJECTOPTS $CDROM
3060 ## Do we need to pre-process
3061 #if [ x"$PREPROCESS" = "x" ] ; then
3064 # for PRETRACKNUM in $TRACKQUEUE
3067 # if [ "$GOAHEAD" = "NO" ]; then break; fi
3069 # until [ $PREPROCEED ]
3071 # if checkstatus readtrack-$PRETRACKNUM; then PREPROCEED=y; break; fi
3072 # # all locations are working, wait and try again later
3073 # if [ ! $PREPROCEED ]; then sleep 3; fi
3075 # ( do_preprocess $PRETRACKNUM
3083 # In batch mode, we want all tracks to be read first.
3084 if [ "$BATCH" = "y" ]; then
3085 read GOAHEAD # For blocking - will contain either "NO" or "NEXTTRACK"
3086 if [ "$GOAHEAD" = "NO" ]; then break; fi
3087 for LASTTRACK in $TRACKQUEUE; do :; done
3088 if checkstatus readtrack-$LASTTRACK; then
3089 if [ "$DONORMALIZE" = "y" ]; then
3090 if checkstatus normalizetrack-$LASTTRACK; then :; else do_batch_normalize; fi
3091 if checkerrors batch-normalize; then exit; fi
3093 if [ "$DOENCODE" = "y" ]; then
3094 if checkstatus encodetrack-$LASTTRACK; then :; else do_batch_encode; fi
3095 if checkerrors batch-encode; then exit; fi
3100 # If we are using ONETRACK, we can proceed with the normal encoding using just the $FIRSTTRACK as TRACKQUEUE
3101 if [ "$ONETRACK" = "y" ] ; then
3102 TRACKQUEUE="$FIRSTTRACK"
3103 TRACKS="$FIRSTTRACK"
3106 # Do the encoding, including parallelization of remote encoding
3107 # Figure out where each track is going to be encoded
3108 ENCODELOCATIONS="$(echo $REMOTEHOSTS | tr , ' ')"
3109 if [ "$MAXPROCS" != "0" ]; then
3110 for NUM in $(f_seq_row 1 "$MAXPROCS")
3112 ENCODELOCATIONS="$ENCODELOCATIONS %local$NUM%"
3116 ENCODELOCATIONS=$(echo $ENCODELOCATIONS)
3117 for UTRACKNUM in $TRACKQUEUE
3120 read GOAHEAD # For blocking - will contain either "NO" or "NEXTTRACK"
3121 if [ "$GOAHEAD" = "NO" ]; then break; fi
3122 # find out where this track is to be encoded
3123 if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
3124 # Make sure we have a place to encode this, if not, exit stage right
3125 if [ -z "$ENCODELOCATIONS" ]; then
3131 for LOCATION in $ENCODELOCATIONS
3133 PREVIOUSTRACK="$(checkstatus encodetracklocation-$LOCATION)"
3134 # check first if a track has ever been assigned to this location
3135 if [ -z "$PREVIOUSTRACK" ]; then PROCEED=y; break; fi
3136 # If it errored out, rebuild $ENCODELOCATIONS without this location in it
3137 if checkerrors encodetrack-$PREVIOUSTRACK; then
3138 for TEMPLOCATION in $ENCODELOCATIONS
3140 if [ "$TEMPLOCATION" != "$LOCATION" ]; then
3141 TEMPENCODELOCATIONS="$TEMPENCODELOCATIONS $TEMPLOCATION"
3144 ENCODELOCATIONS=$(echo $TEMPENCODELOCATIONS)
3149 # We're still here, this location must have been previously assigned,
3150 # and last completed without error - check if it's done with the
3151 # previous track yet
3152 if checkstatus encodetrack-$PREVIOUSTRACK; then PROCEED=y; break; fi
3154 # all locations are working, wait and try again later
3155 if [ ! $PROCEED ]; then sleep 3; fi
3157 # Record the location we're about to encode the next track at
3158 echo "encodetracklocation-$LOCATION=$UTRACKNUM" >> "$ABCDETEMPDIR/status"
3160 # Don't proceed with the rest of the loop if we can't encode
3161 if [ "$ABORT" ]; then continue; fi
3162 # Set TRACKNUM, TRACKNAME
3163 if [ -e "$CDDBDATA" ]; then
3164 if [ "$ONETRACK" = "y" ]; then
3166 TRACKNUM="$FIRSTTRACK"
3169 # TRACKNUM=$(printf %0.${TRACKNUMPADDING}d $(expr ${UTRACKNUM} + 0))
3171 CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
3172 #TRACKNAME="$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2- -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')"
3173 do_getcddbinfo TRACKNAME
3177 # You can't encode a file which needs to be normalized before finishing
3178 # You can't tag a file before it's finished encoding -
3179 # thus all of this is backgrounded together
3181 if [ "$DONORMALIZE" = "y" ]; then
3182 if checkstatus readtrack-$UTRACKNUM; then
3183 if checkstatus normalizetrack-$UTRACKNUM; then :; else do_normalize $UTRACKNUM; fi
3186 if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
3187 if checkstatus readtrack-$UTRACKNUM; then
3188 #if checkstatus encodetrack-$UTRACKNUM; then :; else do_encode $UTRACKNUM $LOCATION; fi
3189 if [ "$DONORMALIZE" = "y" ]; then
3190 if checkstatus normalizetrack-$UTRACKNUM; then
3191 if checkstatus encodetrack-$UTRACKNUM; then :; else do_encode $UTRACKNUM $LOCATION $OUTPUT; fi
3194 if checkstatus encodetrack-$UTRACKNUM; then :; else do_encode $UTRACKNUM $LOCATION $OUTPUT; fi
3198 if [ "$DOTAG" = "y" ]; then
3199 if checkstatus encodetrack-$UTRACKNUM; then
3200 if checkstatus tagtrack-$UTRACKNUM; then :; else do_tag $UTRACKNUM; fi
3202 # Lets tag the cue file
3203 if checkstatus cleancuefile >/dev/null; then :; else
3204 if checkstatus cuefile >/dev/null ; then
3209 if [ "$DOMOVE" = "y" ]; then
3210 if checkstatus tagtrack-$UTRACKNUM; then
3211 if checkstatus movetrack-$UTRACKNUM; then :; else do_move $UTRACKNUM; fi
3218 # Go through it again and make sure there's no distmp3 stragglers, otherwise
3219 # we'll delete the files they're working on
3220 ## FIXME ## Check also for files which are encoded using PIPEs.
3221 if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
3226 for LOCATION in $ENCODELOCATIONS
3228 CHECKTRACK="$(checkstatus encodetracklocation-$LOCATION)"
3229 # "How can he give us a status update, if he's DEAD?"
3230 if checkstatus encodetrack-$CHECKTRACK; then
3233 # Nothing to see here please go quietly back to your homes
3234 if [ -z "$CHECKTRACK" ]; then continue; fi
3235 # You're still here? Maybe there is something...
3236 if checkstatus encodetrack-$CHECKTRACK; then :; else PROCEED= ; break; fi
3239 if [ ! $PROCEED ]; then sleep 5; fi
3242 # If the above didn't catch the stragglers, this will
3244 if [ "$DOREPLAYGAIN" = "y" ]; then
3247 # Check to see if run_command logged any errors
3248 if [ -f "$ABCDETEMPDIR/errors" ]; then
3249 echo "The following commands failed to run:"
3250 cat "$ABCDETEMPDIR/errors"
3254 if [ "$KEEPWAVS" = "y" ];then
3258 if [ "$DOCLEAN" = "y" ]; then
3259 # Wipe all the evidence
3260 # Gimme gimme gimme some more time!
3262 rm -rf "$ABCDETEMPDIR"
3265 echo "Finished. Not cleaning $ABCDETEMPDIR."